(function($){"use strict";$=$&&$.hasOwnProperty("default")?$["default"]:$;function isTypeof(type,arg){return typeof arg===type}var isString=isTypeof.bind(null,"string");var isUndefined=isTypeof.bind(null,"undefined");var isFunction=isTypeof.bind(null,"function");var isNumber=isTypeof.bind(null,"number");function isEmptyObject(obj){return!Object.keys(obj).length}function extend(targetArg,sourceArg){var isTargetBoolean=targetArg===!!targetArg;var i=isTargetBoolean?2:1;var target=isTargetBoolean?sourceArg:targetArg;var isDeep=isTargetBoolean?targetArg:false;for(;i<arguments.length;i++){var source=arguments[i];for(var key in source){var value=source[key];if(!isUndefined(value)){var isObject=value!==null&&typeof value==="object"&&Object.getPrototypeOf(value)===Object.prototype;var isArray=Array.isArray(value);if(isDeep&&(isObject||isArray)){target[key]=extend(true,target[key]||(isArray?[]:{}),value)}else{target[key]=value}}}}return target}function arrayRemove(arr,item){var i=arr.indexOf(item);if(i>-1){arr.splice(i,1)}}function each(obj,fn){if(Array.isArray(obj)||"length"in obj&&isNumber(obj.length)){for(var i=0;i<obj.length;i++){fn(i,obj[i])}}else{Object.keys(obj).forEach(function(key){fn(key,obj[key])})}}var cssPropertyNameCache={};var ELEMENT_NODE=1;var TEXT_NODE=3;function toFloat(value){value=parseFloat(value);return isFinite(value)?value:0}function createElement(tag,attributes,context){var node=(context||document).createElement(tag);each(attributes||{},function(key,value){if(key==="style"){node.style.cssText=value}else if(key in node){node[key]=value}else{node.setAttribute(key,value)}});return node}function parent(node,selector){var parent=node||{};while((parent=parent.parentNode)&&!/(9|11)/.test(parent.nodeType)){if(!selector||is(parent,selector)){return parent}}}function closest(node,selector){return is(node,selector)?node:parent(node,selector)}function remove(node){if(node.parentNode){node.parentNode.removeChild(node)}}function appendChild(node,child){node.appendChild(child)}function find(node,selector){return node.querySelectorAll(selector)}var EVENT_CAPTURE=true;function on(node,events,selector,fn,capture){events.split(" ").forEach(function(event){var handler;if(isString(selector)){handler=fn["_sce-event-"+event+selector]||function(e){var target=e.target;while(target&&target!==node){if(is(target,selector)){fn.call(target,e);return}target=target.parentNode}};fn["_sce-event-"+event+selector]=handler}else{handler=selector;capture=fn}node.addEventListener(event,handler,capture||false)})}function off(node,events,selector,fn,capture){events.split(" ").forEach(function(event){var handler;if(isString(selector)){handler=fn["_sce-event-"+event+selector]}else{handler=selector;capture=fn}node.removeEventListener(event,handler,capture||false)})}function attr(node,attr,value){if(arguments.length<3){return node.getAttribute(attr)}if(value==null){removeAttr(node,attr)}else{node.setAttribute(attr,value)}}function removeAttr(node,attr){node.removeAttribute(attr)}function hide(node){css(node,"display","none")}function show(node){css(node,"display","")}function toggle(node){if(isVisible(node)){hide(node)}else{show(node)}}function css(node,rule,value){if(arguments.length<3){if(isString(rule)){return node.nodeType===1?getComputedStyle(node)[rule]:null}each(rule,function(key,value){css(node,key,value)})}else{var isNumeric=(value||value===0)&&!isNaN(value);node.style[rule]=isNumeric?value+"px":value}}function data(node,key,value){var argsLength=arguments.length;var data={};if(node.nodeType===ELEMENT_NODE){if(argsLength===1){each(node.attributes,function(_,attr){if(/^data\-/i.test(attr.name)){data[attr.name.substr(5)]=attr.value}});return data}if(argsLength===2){return attr(node,"data-"+key)}attr(node,"data-"+key,String(value))}}function is(node,selector){var result=false;if(node&&node.nodeType===ELEMENT_NODE){result=(node.matches||node.msMatchesSelector||node.webkitMatchesSelector).call(node,selector)}return result}function contains(node,child){return node!==child&&node.contains&&node.contains(child)}function previousElementSibling(node,selector){var prev=node.previousElementSibling;if(selector&&prev){return is(prev,selector)?prev:null}return prev}function insertBefore(node,refNode){return refNode.parentNode.insertBefore(node,refNode)}function classes(node){return node.className.trim().split(/\s+/)}function hasClass(node,className){return is(node,"."+className)}function addClass(node,className){var classList=classes(node);if(classList.indexOf(className)<0){classList.push(className)}node.className=classList.join(" ")}function removeClass(node,className){var classList=classes(node);arrayRemove(classList,className);node.className=classList.join(" ")}function toggleClass(node,className,state){state=isUndefined(state)?!hasClass(node,className):state;if(state){addClass(node,className)}else{removeClass(node,className)}}function width(node,value){if(isUndefined(value)){var cs=getComputedStyle(node);var padding=toFloat(cs.paddingLeft)+toFloat(cs.paddingRight);var border=toFloat(cs.borderLeftWidth)+toFloat(cs.borderRightWidth);return node.offsetWidth-padding-border}css(node,"width",value)}function height(node,value){if(isUndefined(value)){var cs=getComputedStyle(node);var padding=toFloat(cs.paddingTop)+toFloat(cs.paddingBottom);var border=toFloat(cs.borderTopWidth)+toFloat(cs.borderBottomWidth);return node.offsetHeight-padding-border}css(node,"height",value)}function trigger(node,eventName,data){var event;if(isFunction(window.CustomEvent)){event=new CustomEvent(eventName,{bubbles:true,cancelable:true,detail:data})}else{event=node.ownerDocument.createEvent("CustomEvent");event.initCustomEvent(eventName,true,true,data)}node.dispatchEvent(event)}function isVisible(node){return!!node.getClientRects().length}function camelCase(string){return string.replace(/^-ms-/,"ms-").replace(/-(\w)/g,function(match,char){return char.toUpperCase()})}function traverse(node,func,innermostFirst,siblingsOnly,reverse){node=reverse?node.lastChild:node.firstChild;while(node){var next=reverse?node.previousSibling:node.nextSibling;if(!innermostFirst&&func(node)===false||!siblingsOnly&&traverse(node,func,innermostFirst,siblingsOnly,reverse)===false||innermostFirst&&func(node)===false){return false}node=next}}function rTraverse(node,func,innermostFirst,siblingsOnly){traverse(node,func,innermostFirst,siblingsOnly,true)}function parseHTML(html,context){context=context||document;var ret=context.createDocumentFragment();var tmp=createElement("div",{},context);tmp.innerHTML=html;while(tmp.firstChild){appendChild(ret,tmp.firstChild)}return ret}function hasStyling(node){return node&&(!is(node,"p,div")||node.className||attr(node,"style")||!isEmptyObject(data(node)))}function convertElement(element,toTagName){var newElement=createElement(toTagName,{},element.ownerDocument);each(element.attributes,function(_,attribute){try{attr(newElement,attribute.name,attribute.value)}catch(ex){}});while(element.firstChild){appendChild(newElement,element.firstChild)}element.parentNode.replaceChild(newElement,element);return newElement}var blockLevelList="|body|hr|p|div|h1|h2|h3|h4|h5|h6|address|pre|"+"form|table|tbody|thead|tfoot|th|tr|td|li|ol|ul|blockquote|center|";function canHaveChildren(node){if(!/11?|9/.test(node.nodeType)){return false}return("|iframe|area|base|basefont|br|col|frame|hr|img|input|wbr"+"|isindex|link|meta|param|command|embed|keygen|source|track|"+"object|").indexOf("|"+node.nodeName.toLowerCase()+"|")<0}function isInline(elm,includeCodeAsBlock){var tagName,nodeType=(elm||{}).nodeType||TEXT_NODE;if(nodeType!==ELEMENT_NODE){return nodeType===TEXT_NODE}tagName=elm.tagName.toLowerCase();if(tagName==="code"){return!includeCodeAsBlock}return blockLevelList.indexOf("|"+tagName+"|")<0}function copyCSS(from,to){to.style.cssText=from.style.cssText+to.style.cssText}function fixNesting(node){var getLastInlineParent=function(node){while(isInline(node.parentNode,true)){node=node.parentNode}return node};traverse(node,function(node){var list="ul,ol",isBlock=!isInline(node,true);if(isBlock&&isInline(node.parentNode,true)){var parent=getLastInlineParent(node),before=extractContents(parent,node),middle=node;copyCSS(parent,middle);insertBefore(before,parent);insertBefore(middle,parent)}if(isBlock&&is(node,list)&&is(node.parentNode,list)){var li=previousElementSibling(node,"li");if(!li){li=createElement("li");insertBefore(li,node)}appendChild(li,node)}})}function findCommonAncestor(node1,node2){while(node1=node1.parentNode){if(contains(node1,node2)){return node1}}}function getSibling(node,previous){if(!node){return null}return(previous?node.previousSibling:node.nextSibling)||getSibling(node.parentNode,previous)}function removeWhiteSpace(root){var nodeValue,nodeType,next,previous,previousSibling,nextNode,trimStart,cssWhiteSpace=css(root,"whiteSpace"),preserveNewLines=/line$/i.test(cssWhiteSpace),node=root.firstChild;if(/pre(\-wrap)?$/i.test(cssWhiteSpace)){return}while(node){nextNode=node.nextSibling;nodeValue=node.nodeValue;nodeType=node.nodeType;if(nodeType===ELEMENT_NODE&&node.firstChild){removeWhiteSpace(node)}if(nodeType===TEXT_NODE){next=getSibling(node);previous=getSibling(node,true);trimStart=false;while(hasClass(previous,"sceditor-ignore")){previous=getSibling(previous,true)}if(isInline(node)&&previous){previousSibling=previous;while(previousSibling.lastChild){previousSibling=previousSibling.lastChild;while(hasClass(previousSibling,"sceditor-ignore")){previousSibling=getSibling(previousSibling,true)}}trimStart=previousSibling.nodeType===TEXT_NODE?/[\t\n\r ]$/.test(previousSibling.nodeValue):!isInline(previousSibling)}nodeValue=nodeValue.replace(/\u200B/g,"");if(!previous||!isInline(previous)||trimStart){nodeValue=nodeValue.replace(preserveNewLines?/^[\t ]+/:/^[\t\n\r ]+/,"")}if(!next||!isInline(next)){nodeValue=nodeValue.replace(preserveNewLines?/[\t ]+$/:/[\t\n\r ]+$/,"")}if(!nodeValue.length){remove(node)}else{node.nodeValue=nodeValue.replace(preserveNewLines?/[\t ]+/g:/[\t\n\r ]+/g," ")}}node=nextNode}}function extractContents(startNode,endNode){var range=startNode.ownerDocument.createRange();range.setStartBefore(startNode);range.setEndAfter(endNode);return range.extractContents()}function getOffset(node){var left=0,top=0;while(node){left+=node.offsetLeft;top+=node.offsetTop;node=node.offsetParent}return{left:left,top:top}}function getStyle(elm,property){var direction,styleValue,elmStyle=elm.style;if(!cssPropertyNameCache[property]){cssPropertyNameCache[property]=camelCase(property)}property=cssPropertyNameCache[property];styleValue=elmStyle[property];if("textAlign"===property){direction=elmStyle.direction;styleValue=styleValue||css(elm,property);if(css(elm.parentNode,property)===styleValue||css(elm,"display")!=="block"||is(elm,"hr,th")){return""}if(/right/i.test(styleValue)&&direction==="rtl"||/left/i.test(styleValue)&&direction==="ltr"){return""}}return styleValue}function hasStyle(elm,property,values){var styleValue=getStyle(elm,property);if(!styleValue){return false}return!values||styleValue===values||Array.isArray(values)&&values.indexOf(styleValue)>-1}var defaultOptions={toolbar:"bold,italic,underline,strike,subscript,superscript|"+"left,center,right,justify|font,size,color,removeformat|"+"cut,copy,pastetext|bulletlist,orderedlist,indent,outdent|"+"table|code,quote|horizontalrule,image,email,link,unlink|"+"emoticon,youtube,date,time|ltr,rtl|print,maximize,source",toolbarExclude:null,style:"jquery.sceditor.default.css",fonts:"Arial,Arial Black,Comic Sans MS,Courier New,Georgia,Impact,"+"Sans-serif,Serif,Times New Roman,Trebuchet MS,Verdana",colors:"#000000,#44B8FF,#1E92F7,#0074D9,#005DC2,#00369B,#b3d5f4|"+"#444444,#C3FFFF,#9DF9FF,#7FDBFF,#68C4E8,#419DC1,#d9f4ff|"+"#666666,#72FF84,#4CEA5E,#2ECC40,#17B529,#008E02,#c0f0c6|"+"#888888,#FFFF44,#FFFA1E,#FFDC00,#E8C500,#C19E00,#fff5b3|"+"#aaaaaa,#FFC95F,#FFA339,#FF851B,#E86E04,#C14700,#ffdbbb|"+"#cccccc,#FF857A,#FF5F54,#FF4136,#E82A1F,#C10300,#ffc6c3|"+"#eeeeee,#FF56FF,#FF30DC,#F012BE,#D900A7,#B20080,#fbb8ec|"+"#ffffff,#F551FF,#CF2BE7,#B10DC9,#9A00B2,#9A00B2,#e8b6ef",locale:attr(document.documentElement,"lang")||"en",charset:"utf-8",emoticonsCompat:false,emoticonsEnabled:true,emoticonsRoot:"",emoticons:{dropdown:{":)":"emoticons/smile.png",":angel:":"emoticons/angel.png",":angry:":"emoticons/angry.png","8-)":"emoticons/cool.png",":'(":"emoticons/cwy.png",":ermm:":"emoticons/ermm.png",":D":"emoticons/grin.png","<3":"emoticons/heart.png",":(":"emoticons/sad.png",":O":"emoticons/shocked.png",":P":"emoticons/tongue.png",";)":"emoticons/wink.png"},more:{":alien:":"emoticons/alien.png",":blink:":"emoticons/blink.png",":blush:":"emoticons/blush.png",":cheerful:":"emoticons/cheerful.png",":devil:":"emoticons/devil.png",":dizzy:":"emoticons/dizzy.png",":getlost:":"emoticons/getlost.png",":happy:":"emoticons/happy.png",":kissing:":"emoticons/kissing.png",":ninja:":"emoticons/ninja.png",":pinch:":"emoticons/pinch.png",":pouty:":"emoticons/pouty.png",":sick:":"emoticons/sick.png",":sideways:":"emoticons/sideways.png",":silly:":"emoticons/silly.png",":sleeping:":"emoticons/sleeping.png",":unsure:":"emoticons/unsure.png",":woot:":"emoticons/w00t.png",":wassat:":"emoticons/wassat.png"},hidden:{":whistling:":"emoticons/whistling.png",":love:":"emoticons/wub.png"}},width:null,height:null,resizeEnabled:true,resizeMinWidth:null,resizeMinHeight:null,resizeMaxHeight:null,resizeMaxWidth:null,resizeHeight:true,resizeWidth:true,dateFormat:"year-month-day",toolbarContainer:null,enablePasteFiltering:false,disablePasting:false,readOnly:false,rtl:false,autofocus:false,autofocusEnd:true,autoExpand:false,autoUpdate:false,spellcheck:true,runWithoutWysiwygSupport:false,startInSourceMode:false,id:null,plugins:"",zIndex:null,bbcodeTrim:false,disableBlockRemove:false,parserOptions:{},dropDownCss:{}};var USER_AGENT=navigator.userAgent;var ie=function(){var undef,v=3,doc=document,div=doc.createElement("div"),all=div.getElementsByTagName("i");do{div.innerHTML="\x3c!--[if gt IE "+ ++v+"]><i></i><![endif]--\x3e"}while(all[0]);if(doc.documentMode&&doc.all&&window.atob){v=10}if(v===4&&doc.documentMode){v=11}return v>4?v:undef}();var edge="-ms-ime-align"in document.documentElement.style;var ios=/iPhone|iPod|iPad| wosbrowser\//i.test(USER_AGENT);var isWysiwygSupported=function(){var match,isUnsupported;var div=document.createElement("div");div.contentEditable=true;if(!("contentEditable"in document.documentElement)||div.contentEditable!=="true"){return false}isUnsupported=/Opera Mobi|Opera Mini/i.test(USER_AGENT);if(/Android/i.test(USER_AGENT)){isUnsupported=true;if(/Safari/.test(USER_AGENT)){match=/Safari\/(\d+)/.exec(USER_AGENT);isUnsupported=!match||!match[1]?true:match[1]<534}}if(/ Silk\//i.test(USER_AGENT)){match=/AppleWebKit\/(\d+)/.exec(USER_AGENT);isUnsupported=!match||!match[1]?true:match[1]<534}if(ios){isUnsupported=/OS [0-4](_\d)+ like Mac/i.test(USER_AGENT)}if(/Firefox/i.test(USER_AGENT)){isUnsupported=false}if(/OneBrowser/i.test(USER_AGENT)){isUnsupported=false}if(navigator.vendor==="UCWEB"){isUnsupported=false}if(ie<=9){isUnsupported=true}return!isUnsupported}();var VALID_SCHEME_REGEX=/^(https?|s?ftp|mailto|spotify|skype|ssh|teamspeak|tel):|(\/\/)|data:image\/(png|bmp|gif|p?jpe?g);/i;function regex(str){return str.replace(/([\-.*+?^=!:${}()|\[\]\/\\])/g,"\\$1")}function entities(str,noQuotes){if(!str){return str}var replacements={"&":"&amp;","<":"&lt;",">":"&gt;","  ":"&nbsp; ","\r\n":"<br />","\r":"<br />","\n":"<br />"};if(noQuotes!==false){replacements['"']="&#34;";replacements["'"]="&#39;";replacements["`"]="&#96;"}str=str.replace(/ {2}|\r\n|[&<>\r\n'"`]/g,function(match){return replacements[match]||match});return str}function uriScheme(url){var path,hasScheme=/^[^\/]*:/i,location=window.location;if(!url||!hasScheme.test(url)||VALID_SCHEME_REGEX.test(url)){return url}path=location.pathname.split("/");path.pop();return location.protocol+"//"+location.host+path.join("/")+"/"+url}var _templates={html:"<!DOCTYPE html>"+"<html{attrs}>"+"<head>"+"<style>.ie * {min-height: auto !important} "+".ie table td {height:15px} "+"@supports (-ms-ime-align:auto) { "+"* { min-height: auto !important; } "+"}"+"</style>"+'<meta http-equiv="Content-Type" '+'content="text/html;charset={charset}" />'+'<link rel="stylesheet" type="text/css" href="{style}" />'+"</head>"+'<body contenteditable="true" {spellcheck}><p></p></body>'+"</html>",toolbarButton:'<a class="sceditor-button sceditor-button-{name}" '+'data-sceditor-command="{name}" unselectable="on">'+'<div unselectable="on">{dispName}</div></a>',emoticon:'<img src="{url}" data-sceditor-emoticon="{key}" '+'alt="{key}" title="{tooltip}" />',fontOpt:'<a class="sceditor-font-option" href="#" '+'data-font="{font}"><font face="{font}">{font}</font></a>',sizeOpt:'<a class="sceditor-fontsize-option" data-size="{size}" '+'href="#"><font size="{size}">{size}</font></a>',pastetext:'<div><label for="txt">{label}</label> '+'<textarea cols="20" rows="7" id="txt"></textarea></div>'+'<div><input type="button" class="button" value="{insert}" />'+"</div>",table:'<div><label for="rows">{rows}</label><input type="text" '+'id="rows" value="2" /></div>'+'<div><label for="cols">{cols}</label><input type="text" '+'id="cols" value="2" /></div>'+'<div><input type="button" class="button" value="{insert}"'+" /></div>",image:'<div><label for="link">{url}</label> '+'<input type="text" id="image" dir="ltr" placeholder="https://" /></div>'+'<div><label for="width">{width}</label> '+'<input type="text" id="width" size="2" dir="ltr" /></div>'+'<div><label for="height">{height}</label> '+'<input type="text" id="height" size="2" dir="ltr" /></div>'+'<div><input type="button" class="button" value="{insert}" />'+"</div>",email:'<div><label for="email">{label}</label> '+'<input type="text" id="email" dir="ltr" /></div>'+'<div><label for="des">{desc}</label> '+'<input type="text" id="des" /></div>'+'<div><input type="button" class="button" value="{insert}" />'+"</div>",link:'<div><label for="link">{url}</label> '+'<input type="text" id="link" dir="ltr" placeholder="https://" /></div>'+'<div><label for="des">{desc}</label> '+'<input type="text" id="des" /></div>'+'<div><input type="button" class="button" value="{ins}" /></div>',youtubeMenu:'<div><label for="link">{label}</label> '+'<input type="text" id="link" dir="ltr" placeholder="https://" /></div>'+'<div><input type="button" class="button" value="{insert}" />'+"</div>",youtube:'<iframe width="560" height="315" frameborder="0" allowfullscreen '+'src="https://www.youtube.com/embed/{id}?wmode=opaque&start={time}" '+'data-youtube-id="{id}"></iframe>'};function _tmpl(name,params,createHtml){var template=_templates[name];Object.keys(params).forEach(function(name){template=template.replace(new RegExp(regex("{"+name+"}"),"g"),params[name])});if(createHtml){template=parseHTML(template)}return template}var IE_BR_FIX=ie&&ie<11;function fixFirefoxListBug(editor){if("mozHidden"in document){var node=editor.getBody();var next;while(node){next=node;if(next.firstChild){next=next.firstChild}else{while(next&&!next.nextSibling){next=next.parentNode}if(next){next=next.nextSibling}}if(node.nodeType===3&&/[\n\r\t]+/.test(node.nodeValue)){if(!/^pre/.test(css(node.parentNode,"whiteSpace"))){remove(node)}}node=next}}}var defaultCmds={bold:{exec:"bold",tooltip:"Bold",shortcut:"Ctrl+B"},italic:{exec:"italic",tooltip:"Italic",shortcut:"Ctrl+I"},underline:{exec:"underline",tooltip:"Underline",shortcut:"Ctrl+U"},strike:{exec:"strikethrough",tooltip:"Strikethrough"},subscript:{exec:"subscript",tooltip:"Subscript"},superscript:{exec:"superscript",tooltip:"Superscript"},left:{state:function(node){if(node&&node.nodeType===3){node=node.parentNode}if(node){var isLtr=css(node,"direction")==="ltr";var align=css(node,"textAlign");return align==="left"||align===(isLtr?"start":"end")}},exec:"justifyleft",tooltip:"Align left"},center:{exec:"justifycenter",tooltip:"Center"},right:{state:function(node){if(node&&node.nodeType===3){node=node.parentNode}if(node){var isLtr=css(node,"direction")==="ltr";var align=css(node,"textAlign");return align==="right"||align===(isLtr?"end":"start")}},exec:"justifyright",tooltip:"Align right"},justify:{exec:"justifyfull",tooltip:"Justify"},font:{_dropDown:function(editor,caller,callback){var content=createElement("div");on(content,"click","a",function(e){callback(data(this,"font"));editor.closeDropDown(true);e.preventDefault()});editor.opts.fonts.split(",").forEach(function(font){appendChild(content,_tmpl("fontOpt",{font:font},true))});editor.createDropDown(caller,"font-picker",content)},exec:function(caller){var editor=this;defaultCmds.font._dropDown(editor,caller,function(fontName){editor.execCommand("fontname",fontName)})},tooltip:"Font Name"},size:{_dropDown:function(editor,caller,callback){var content=createElement("div");on(content,"click","a",function(e){callback(data(this,"size"));editor.closeDropDown(true);e.preventDefault()});for(var i=1;i<=7;i++){appendChild(content,_tmpl("sizeOpt",{size:i},true))}editor.createDropDown(caller,"fontsize-picker",content)},exec:function(caller){var editor=this;defaultCmds.size._dropDown(editor,caller,function(fontSize){editor.execCommand("fontsize",fontSize)})},tooltip:"Font Size"},color:{_dropDown:function(editor,caller,callback){var content=createElement("div"),html="",cmd=defaultCmds.color;if(!cmd._htmlCache){editor.opts.colors.split("|").forEach(function(column){html+='<div class="sceditor-color-column">';column.split(",").forEach(function(color){html+='<a href="#" class="sceditor-color-option"'+' style="background-color: '+color+'"'+' data-color="'+color+'"></a>'});html+="</div>"});cmd._htmlCache=html}appendChild(content,parseHTML(cmd._htmlCache));on(content,"click","a",function(e){callback(data(this,"color"));editor.closeDropDown(true);e.preventDefault()});editor.createDropDown(caller,"color-picker",content)},exec:function(caller){var editor=this;defaultCmds.color._dropDown(editor,caller,function(color){editor.execCommand("forecolor",color)})},tooltip:"Font Color"},removeformat:{exec:"removeformat",tooltip:"Remove Formatting"},cut:{exec:"cut",tooltip:"Cut",errorMessage:"Your browser does not allow the cut command. "+"Please use the keyboard shortcut Ctrl/Cmd-X"},copy:{exec:"copy",tooltip:"Copy",errorMessage:"Your browser does not allow the copy command. "+"Please use the keyboard shortcut Ctrl/Cmd-C"},paste:{exec:"paste",tooltip:"Paste",errorMessage:"Your browser does not allow the paste command. "+"Please use the keyboard shortcut Ctrl/Cmd-V"},pastetext:{exec:function(caller){var val,content=createElement("div"),editor=this;appendChild(content,_tmpl("pastetext",{label:editor._("Paste your text inside the following box:"),insert:editor._("Insert")},true));on(content,"click",".button",function(e){val=find(content,"#txt")[0].value;if(val){editor.wysiwygEditorInsertText(val)}editor.closeDropDown(true);e.preventDefault()});editor.createDropDown(caller,"pastetext",content)},tooltip:"Paste Text"},bulletlist:{exec:function(){fixFirefoxListBug(this);this.execCommand("insertunorderedlist")},tooltip:"Bullet list"},orderedlist:{exec:function(){fixFirefoxListBug(this);this.execCommand("insertorderedlist")},tooltip:"Numbered list"},indent:{state:function(parent$$1,firstBlock){var range,startParent,endParent;if(is(firstBlock,"li")){return 0}if(is(firstBlock,"ul,ol,menu")){range=this.getRangeHelper().selectedRange();startParent=range.startContainer.parentNode;endParent=range.endContainer.parentNode;if(startParent!==startParent.parentNode.firstElementChild||is(endParent,"li")&&endParent!==endParent.parentNode.lastElementChild){return 0}}return-1},exec:function(){var editor=this,block=editor.getRangeHelper().getFirstBlockParent();editor.focus();if(closest(block,"ul,ol,menu")){editor.execCommand("indent")}},tooltip:"Add indent"},outdent:{state:function(parents$$1,firstBlock){return closest(firstBlock,"ul,ol,menu")?0:-1},exec:function(){var block=this.getRangeHelper().getFirstBlockParent();if(closest(block,"ul,ol,menu")){this.execCommand("outdent")}},tooltip:"Remove one indent"},table:{exec:function(caller){var editor=this,content=createElement("div");appendChild(content,_tmpl("table",{rows:editor._("Rows:"),cols:editor._("Cols:"),insert:editor._("Insert")},true));on(content,"click",".button",function(e){var rows=Number(find(content,"#rows")[0].value),cols=Number(find(content,"#cols")[0].value),html="<table>";if(rows>0&&cols>0){html+=Array(rows+1).join("<tr>"+Array(cols+1).join("<td>"+(IE_BR_FIX?"":"<br />")+"</td>")+"</tr>");html+="</table>";editor.wysiwygEditorInsertHtml(html);editor.closeDropDown(true);e.preventDefault()}});editor.createDropDown(caller,"inserttable",content)},tooltip:"Insert a table"},horizontalrule:{exec:"inserthorizontalrule",tooltip:"Insert a horizontal rule"},code:{exec:function(){this.wysiwygEditorInsertHtml("<code>",(IE_BR_FIX?"":"<br />")+"</code>")},tooltip:"Code"},image:{_dropDown:function(editor,caller,selected,cb){var content=createElement("div");appendChild(content,_tmpl("image",{url:editor._("URL:"),width:editor._("Width (optional):"),height:editor._("Height (optional):"),insert:editor._("Insert")},true));var urlInput=find(content,"#image")[0];urlInput.value=selected;on(content,"click",".button",function(e){if(urlInput.value){cb(urlInput.value,find(content,"#width")[0].value,find(content,"#height")[0].value)}editor.closeDropDown(true);e.preventDefault()});editor.createDropDown(caller,"insertimage",content)},exec:function(caller){var editor=this;defaultCmds.image._dropDown(editor,caller,"",function(url,width$$1,height$$1){var attrs="";if(width$$1){attrs+=' width="'+width$$1+'"'}if(height$$1){attrs+=' height="'+height$$1+'"'}editor.wysiwygEditorInsertHtml("<img"+attrs+' src="'+url+'" />')})},tooltip:"Insert an image"},email:{_dropDown:function(editor,caller,cb){var content=createElement("div");appendChild(content,_tmpl("email",{label:editor._("E-mail:"),desc:editor._("Description (optional):"),insert:editor._("Insert")},true));on(content,"click",".button",function(e){var email=find(content,"#email")[0].value;if(email){cb(email,find(content,"#des")[0].value)}editor.closeDropDown(true);e.preventDefault()});editor.createDropDown(caller,"insertemail",content)},exec:function(caller){var editor=this;defaultCmds.email._dropDown(editor,caller,function(email,text){editor.focus();if(!editor.getRangeHelper().selectedHtml()||text){editor.wysiwygEditorInsertHtml('<a href="'+"mailto:"+email+'">'+(text||email)+"</a>")}else{editor.execCommand("createlink","mailto:"+email)}})},tooltip:"Insert an email"},link:{_dropDown:function(editor,caller,cb){var content=createElement("div");appendChild(content,_tmpl("link",{url:editor._("URL:"),desc:editor._("Description (optional):"),ins:editor._("Insert")},true));var linkInput=find(content,"#link")[0];function insertUrl(e){if(linkInput.value){cb(linkInput.value,find(content,"#des")[0].value)}editor.closeDropDown(true);e.preventDefault()}on(content,"click",".button",insertUrl);on(content,"keypress",function(e){if(e.which===13&&linkInput.value){insertUrl(e)}},EVENT_CAPTURE);editor.createDropDown(caller,"insertlink",content)},exec:function(caller){var editor=this;defaultCmds.link._dropDown(editor,caller,function(url,text){editor.focus();if(text||!editor.getRangeHelper().selectedHtml()){text=text||url;editor.wysiwygEditorInsertHtml('<a href="'+url+'">'+text+"</a>")}else{editor.execCommand("createlink",url)}})},tooltip:"Insert a link"},unlink:{state:function(){return closest(this.currentNode(),"a")?0:-1},exec:function(){var anchor=closest(this.currentNode(),"a");if(anchor){while(anchor.firstChild){insertBefore(anchor.firstChild,anchor)}remove(anchor)}},tooltip:"Unlink"},quote:{exec:function(caller,html,author){var before="<blockquote>",end="</blockquote>";if(html){author=author?"<cite>"+author+"</cite>":"";before=before+author+html+end;end=null}else if(this.getRangeHelper().selectedHtml()===""){end=(IE_BR_FIX?"":"<br />")+end}this.wysiwygEditorInsertHtml(before,end)},tooltip:"Insert a Quote"},emoticon:{exec:function(caller){var editor=this;var createContent=function(includeMore){var moreLink,opts=editor.opts,emoticonsRoot=opts.emoticonsRoot||"",emoticonsCompat=opts.emoticonsCompat,rangeHelper=editor.getRangeHelper(),startSpace=emoticonsCompat&&rangeHelper.getOuterText(true,1)!==" "?" ":"",endSpace=emoticonsCompat&&rangeHelper.getOuterText(false,1)!==" "?" ":"",content=createElement("div"),line=createElement("div"),perLine=0,emoticons=extend({},opts.emoticons.dropdown,includeMore?opts.emoticons.more:{});appendChild(content,line);perLine=Math.sqrt(Object.keys(emoticons).length);on(content,"click","img",function(e){editor.insert(startSpace+attr(this,"alt")+endSpace,null,false).closeDropDown(true);e.preventDefault()});each(emoticons,function(code,emoticon){appendChild(line,createElement("img",{src:emoticonsRoot+(emoticon.url||emoticon),alt:code,title:emoticon.tooltip||code}));if(line.children.length>=perLine){line=createElement("div");appendChild(content,line)}});if(!includeMore&&opts.emoticons.more){moreLink=createElement("a",{className:"sceditor-more"});appendChild(moreLink,document.createTextNode(editor._("More")));on(moreLink,"click",function(e){editor.createDropDown(caller,"more-emoticons",createContent(true));e.preventDefault()});appendChild(content,moreLink)}return content};editor.createDropDown(caller,"emoticons",createContent(false))},txtExec:function(caller){defaultCmds.emoticon.exec.call(this,caller)},tooltip:"Insert an emoticon"},youtube:{_dropDown:function(editor,caller,callback){var content=createElement("div");appendChild(content,_tmpl("youtubeMenu",{label:editor._("Video URL:"),insert:editor._("Insert")},true));on(content,"click",".button",function(e){var val=find(content,"#link")[0].value;var idMatch=val.match(/(?:v=|v\/|embed\/|youtu.be\/)(.{11})/);var timeMatch=val.match(/[&|?](?:star)?t=((\d+[hms]?){1,3})/);var time=0;if(timeMatch){each(timeMatch[1].split(/[hms]/),function(i,val){if(val!==""){time=time*60+Number(val)}})}if(idMatch&&/^[a-zA-Z0-9_\-]{11}$/.test(idMatch[1])){callback(idMatch[1],time)}editor.closeDropDown(true);e.preventDefault()});editor.createDropDown(caller,"insertlink",content)},exec:function(btn){var editor=this;defaultCmds.youtube._dropDown(editor,btn,function(id,time){editor.wysiwygEditorInsertHtml(_tmpl("youtube",{id:id,time:time}))})},tooltip:"Insert a YouTube video"},date:{_date:function(editor){var now=new Date,year=now.getYear(),month=now.getMonth()+1,day=now.getDate();if(year<2e3){year=1900+year}if(month<10){month="0"+month}if(day<10){day="0"+day}return editor.opts.dateFormat.replace(/year/i,year).replace(/month/i,month).replace(/day/i,day)},exec:function(){this.insertText(defaultCmds.date._date(this))},txtExec:function(){this.insertText(defaultCmds.date._date(this))},tooltip:"Insert current date"},time:{_time:function(){var now=new Date,hours=now.getHours(),mins=now.getMinutes(),secs=now.getSeconds();if(hours<10){hours="0"+hours}if(mins<10){mins="0"+mins}if(secs<10){secs="0"+secs}return hours+":"+mins+":"+secs},exec:function(){this.insertText(defaultCmds.time._time())},txtExec:function(){this.insertText(defaultCmds.time._time())},tooltip:"Insert current time"},ltr:{state:function(parents$$1,firstBlock){return firstBlock&&firstBlock.style.direction==="ltr"},exec:function(){var editor=this,rangeHelper=editor.getRangeHelper(),node=rangeHelper.getFirstBlockParent();editor.focus();if(!node||is(node,"body")){editor.execCommand("formatBlock","p");node=rangeHelper.getFirstBlockParent();if(!node||is(node,"body")){return}}var toggleValue=css(node,"direction")==="ltr"?"":"ltr";css(node,"direction",toggleValue)},tooltip:"Left-to-Right"},rtl:{state:function(parents$$1,firstBlock){return firstBlock&&firstBlock.style.direction==="rtl"},exec:function(){var editor=this,rangeHelper=editor.getRangeHelper(),node=rangeHelper.getFirstBlockParent();editor.focus();if(!node||is(node,"body")){editor.execCommand("formatBlock","p");node=rangeHelper.getFirstBlockParent();if(!node||is(node,"body")){return}}var toggleValue=css(node,"direction")==="rtl"?"":"rtl";css(node,"direction",toggleValue)},tooltip:"Right-to-Left"},print:{exec:"print",tooltip:"Print"},maximize:{state:function(){return this.maximize()},exec:function(){this.maximize(!this.maximize())},txtExec:function(){this.maximize(!this.maximize())},tooltip:"Maximize",shortcut:"Ctrl+Shift+M"},source:{state:function(){return this.sourceMode()},exec:function(){this.toggleSourceMode()},txtExec:function(){this.toggleSourceMode()},tooltip:"View source",shortcut:"Ctrl+Shift+S"},ignore:{}};var plugins={};function PluginManager(thisObj){var base=this;var registeredPlugins=[];var formatSignalName=function(signal){return"signal"+signal.charAt(0).toUpperCase()+signal.slice(1)};var callHandlers=function(args,returnAtFirst){args=[].slice.call(args);var idx,ret,signal=formatSignalName(args.shift());for(idx=0;idx<registeredPlugins.length;idx++){if(signal in registeredPlugins[idx]){ret=registeredPlugins[idx][signal].apply(thisObj,args);if(returnAtFirst){return ret}}}};base.call=function(){callHandlers(arguments,false)};base.callOnlyFirst=function(){return callHandlers(arguments,true)};base.hasHandler=function(signal){var i=registeredPlugins.length;signal=formatSignalName(signal);while(i--){if(signal in registeredPlugins[i]){return true}}return false};base.exists=function(plugin){if(plugin in plugins){plugin=plugins[plugin];return typeof plugin==="function"&&typeof plugin.prototype==="object"}return false};base.isRegistered=function(plugin){if(base.exists(plugin)){var idx=registeredPlugins.length;while(idx--){if(registeredPlugins[idx]instanceof plugins[plugin]){return true}}}return false};base.register=function(plugin){if(!base.exists(plugin)||base.isRegistered(plugin)){return false}plugin=new plugins[plugin];registeredPlugins.push(plugin);if("init"in plugin){plugin.init.call(thisObj)}return true};base.deregister=function(plugin){var removedPlugin,pluginIdx=registeredPlugins.length,removed=false;if(!base.isRegistered(plugin)){return removed}while(pluginIdx--){if(registeredPlugins[pluginIdx]instanceof plugins[plugin]){removedPlugin=registeredPlugins.splice(pluginIdx,1)[0];removed=true;if("destroy"in removedPlugin){removedPlugin.destroy.call(thisObj)}}}return removed};base.destroy=function(){var i=registeredPlugins.length;while(i--){if("destroy"in registeredPlugins[i]){registeredPlugins[i].destroy.call(thisObj)}}registeredPlugins=[];thisObj=null}}PluginManager.plugins=plugins;var IE_BR_FIX$1=ie&&ie<11;var outerText=function(range,isLeft,length){var nodeValue,remaining,start,end,node,text="",next=range.startContainer,offset=range.startOffset;if(next&&next.nodeType!==3){next=next.childNodes[offset];offset=0}start=end=offset;while(length>text.length&&next&&next.nodeType===3){nodeValue=next.nodeValue;remaining=length-text.length;if(node){end=nodeValue.length;start=0}node=next;if(isLeft){start=Math.max(end-remaining,0);offset=start;text=nodeValue.substr(start,end-start)+text;next=node.previousSibling}else{end=Math.min(remaining,nodeValue.length);offset=start+end;text+=nodeValue.substr(start,end);next=node.nextSibling}}return{node:node||next,offset:offset,text:text}};function RangeHelper(win,d){var _createMarker,_prepareInput,doc=d||win.contentDocument||win.document,startMarker="sceditor-start-marker",endMarker="sceditor-end-marker",base=this;base.insertHTML=function(html,endHTML){var node,div,range=base.selectedRange();if(!range){return false}if(endHTML){html+=base.selectedHtml()+endHTML}div=createElement("p",{},doc);node=doc.createDocumentFragment();div.innerHTML=html;while(div.firstChild){appendChild(node,div.firstChild)}base.insertNode(node)};_prepareInput=function(node,endNode,returnHtml){var lastChild,frag=doc.createDocumentFragment();if(typeof node==="string"){if(endNode){node+=base.selectedHtml()+endNode}frag=parseHTML(node)}else{appendChild(frag,node);if(endNode){appendChild(frag,base.selectedRange().extractContents());appendChild(frag,endNode)}}if(!(lastChild=frag.lastChild)){return}while(!isInline(lastChild.lastChild,true)){lastChild=lastChild.lastChild}if(canHaveChildren(lastChild)){if(!lastChild.lastChild){appendChild(lastChild,document.createTextNode("​"))}}else{lastChild=frag}base.removeMarkers();appendChild(lastChild,_createMarker(startMarker));appendChild(lastChild,_createMarker(endMarker));if(returnHtml){var div=createElement("div");appendChild(div,frag);return div.innerHTML}return frag};base.insertNode=function(node,endNode){var input=_prepareInput(node,endNode),range=base.selectedRange(),parent$$1=range.commonAncestorContainer;if(!input){return false}range.deleteContents();if(parent$$1&&parent$$1.nodeType!==3&&!canHaveChildren(parent$$1)){insertBefore(input,parent$$1)}else{range.insertNode(input)}base.restoreRange()};base.cloneSelected=function(){var range=base.selectedRange();if(range){return range.cloneRange()}};base.selectedRange=function(){var range,firstChild,sel=win.getSelection();if(!sel){return}if(sel.rangeCount<=0){firstChild=doc.body;while(firstChild.firstChild){firstChild=firstChild.firstChild}range=doc.createRange();range.setStartBefore(firstChild);sel.addRange(range)}if(sel.rangeCount>0){range=sel.getRangeAt(0)}return range};base.hasSelection=function(){var sel=win.getSelection();return sel&&sel.rangeCount>0};base.selectedHtml=function(){var div,range=base.selectedRange();if(range){div=createElement("p",{},doc);appendChild(div,range.cloneContents());return div.innerHTML}return""};base.parentNode=function(){var range=base.selectedRange();if(range){return range.commonAncestorContainer}};base.getFirstBlockParent=function(node){var func=function(elm){if(!isInline(elm,true)){return elm}elm=elm?elm.parentNode:null;return elm?func(elm):elm};return func(node||base.parentNode())};base.insertNodeAt=function(start,node){var currentRange=base.selectedRange(),range=base.cloneSelected();if(!range){return false}range.collapse(start);range.insertNode(node);base.selectRange(currentRange)};_createMarker=function(id){base.removeMarker(id);var marker=createElement("span",{id:id,className:"sceditor-selection sceditor-ignore",style:"display:none;line-height:0"},doc);marker.innerHTML=" ";return marker};base.insertMarkers=function(){var currentRange=base.selectedRange();var startNode=_createMarker(startMarker);base.removeMarkers();base.insertNodeAt(true,startNode);if(currentRange&&currentRange.collapsed){startNode.parentNode.insertBefore(_createMarker(endMarker),startNode.nextSibling)}else{base.insertNodeAt(false,_createMarker(endMarker))}};base.getMarker=function(id){return doc.getElementById(id)};base.removeMarker=function(id){var marker=base.getMarker(id);if(marker){remove(marker)}};base.removeMarkers=function(){base.removeMarker(startMarker);base.removeMarker(endMarker)};base.saveRange=function(){base.insertMarkers()};base.selectRange=function(range){var lastChild;var sel=win.getSelection();var container=range.endContainer;if(!IE_BR_FIX$1&&range.collapsed&&container&&!isInline(container,true)){lastChild=container.lastChild;while(lastChild&&is(lastChild,".sceditor-ignore")){lastChild=lastChild.previousSibling}if(is(lastChild,"br")){var rng=doc.createRange();rng.setEndAfter(lastChild);rng.collapse(false);if(base.compare(range,rng)){range.setStartBefore(lastChild);range.collapse(true)}}}if(sel){base.clear();sel.addRange(range)}};base.restoreRange=function(){var isCollapsed,range=base.selectedRange(),start=base.getMarker(startMarker),end=base.getMarker(endMarker);if(!start||!end||!range){return false}isCollapsed=start.nextSibling===end;range=doc.createRange();range.setStartBefore(start);range.setEndAfter(end);if(isCollapsed){range.collapse(true)}base.selectRange(range);base.removeMarkers()};base.selectOuterText=function(left,right){var start,end,range=base.cloneSelected();if(!range){return false}range.collapse(false);start=outerText(range,true,left);end=outerText(range,false,right);range.setStart(start.node,start.offset);range.setEnd(end.node,end.offset);base.selectRange(range)};base.getOuterText=function(before,length){var range=base.cloneSelected();if(!range){return""}range.collapse(!before);return outerText(range,before,length).text};base.replaceKeyword=function(keywords,includeAfter,keywordsSorted,longestKeyword,requireWhitespace,keypressChar){if(!keywordsSorted){keywords.sort(function(a,b){return a[0].length-b[0].length})}var outerText,match,matchPos,startIndex,leftLen,charsLeft,keyword,keywordLen,whitespaceRegex="(^|[\\s    ])",keywordIdx=keywords.length,whitespaceLen=requireWhitespace?1:0,maxKeyLen=longestKeyword||keywords[keywordIdx-1][0].length;if(requireWhitespace){maxKeyLen++}keypressChar=keypressChar||"";outerText=base.getOuterText(true,maxKeyLen);leftLen=outerText.length;outerText+=keypressChar;if(includeAfter){outerText+=base.getOuterText(false,maxKeyLen)}while(keywordIdx--){keyword=keywords[keywordIdx][0];keywordLen=keyword.length;startIndex=Math.max(0,leftLen-keywordLen-whitespaceLen);matchPos=-1;if(requireWhitespace){match=outerText.substr(startIndex).match(new RegExp(whitespaceRegex+regex(keyword)+whitespaceRegex));if(match){matchPos=match.index+startIndex+match[1].length}}else{matchPos=outerText.indexOf(keyword,startIndex)}if(matchPos>-1){if(matchPos<=leftLen&&matchPos+keywordLen+whitespaceLen>=leftLen){charsLeft=leftLen-matchPos;base.selectOuterText(charsLeft,keywordLen-charsLeft-(/^\S/.test(keypressChar)?1:0));base.insertHTML(keywords[keywordIdx][1]);return true}}}return false};base.compare=function(rngA,rngB){if(!rngB){rngB=base.selectedRange()}if(!rngA||!rngB){return!rngA&&!rngB}return rngA.compareBoundaryPoints(Range.END_TO_END,rngB)===0&&rngA.compareBoundaryPoints(Range.START_TO_START,rngB)===0};base.clear=function(){var sel=win.getSelection();if(sel){if(sel.removeAllRanges){sel.removeAllRanges()}else if(sel.empty){sel.empty()}}}}function checkWhitespace(node,rangeHelper){var noneWsRegex=/[^\s\xA0\u2002\u2003\u2009\u00a0]+/;var emoticons=node&&find(node,"img[data-sceditor-emoticon]");if(!node||!emoticons.length){return}for(var i=0;i<emoticons.length;i++){var emoticon=emoticons[i];var parent$$1=emoticon.parentNode;var prev=emoticon.previousSibling;var next=emoticon.nextSibling;if((!prev||!noneWsRegex.test(prev.nodeValue.slice(-1)))&&(!next||!noneWsRegex.test((next.nodeValue||"")[0]))){continue}var range=rangeHelper.cloneSelected();var rangeStart=-1;var rangeStartContainer=range.startContainer;var previousText=prev.nodeValue;if(previousText===null){previousText=prev.innerText||""}previousText+=data(emoticon,"sceditor-emoticon");if(rangeStartContainer===next){rangeStart=previousText.length+range.startOffset}if(rangeStartContainer===node&&node.childNodes[range.startOffset]===next){rangeStart=previousText.length}if(rangeStartContainer===prev){rangeStart=range.startOffset}if(!next||next.nodeType!==TEXT_NODE){next=parent$$1.insertBefore(parent$$1.ownerDocument.createTextNode(""),next)}next.insertData(0,previousText);remove(prev);remove(emoticon);if(rangeStart>-1){range.setStart(next,rangeStart);range.collapse(true);rangeHelper.selectRange(range)}}}function replace(root,emoticons,emoticonsCompat){var doc=root.ownerDocument;var space="(^|\\s| | | | |$)";var emoticonCodes=[];var emoticonRegex={};if(parent(root,"code")){return}each(emoticons,function(key){emoticonRegex[key]=new RegExp(space+regex(key)+space);emoticonCodes.push(key)});emoticonCodes.sort(function(a,b){return b.length-a.length});(function convert(node){node=node.firstChild;while(node){if(node.nodeType===ELEMENT_NODE&&!is(node,"code")){convert(node)}if(node.nodeType===TEXT_NODE){for(var i=0;i<emoticonCodes.length;i++){var text=node.nodeValue;var key=emoticonCodes[i];var index=emoticonsCompat?text.search(emoticonRegex[key]):text.indexOf(key);if(index>-1){var startIndex=text.indexOf(key,index);var fragment=parseHTML(emoticons[key],doc);var after=text.substr(startIndex+key.length);fragment.appendChild(doc.createTextNode(after));node.nodeValue=text.substr(0,startIndex);node.parentNode.insertBefore(fragment,node.nextSibling)}}}node=node.nextSibling}})(root)}var globalWin=window;var globalDoc=document;var IE_VER=ie;var IE_BR_FIX$2=IE_VER&&IE_VER<11;var IMAGE_MIME_REGEX=/^image\/(p?jpe?g|gif|png|bmp)$/i;function wrapInlines(body,doc){var wrapper;traverse(body,function(node){if(isInline(node,true)){if(!wrapper){wrapper=createElement("p",{},doc);insertBefore(wrapper,node)}if(node.nodeType!==TEXT_NODE||node.nodeValue!==""){appendChild(wrapper,node)}}else{wrapper=null}},false,true)}function SCEditor(original,userOptions){var base=this;var format;var editorContainer;var eventHandlers={};var toolbar;var wysiwygEditor;var wysiwygWindow;var wysiwygBody;var wysiwygDocument;var sourceEditor;var dropdown;var lastRange;var isComposing;var valueChangedKeyUpTimer;var locale;var preLoadCache=[];var rangeHelper;var btnStateHandlers=[];var pluginManager;var currentNode;var currentBlockNode;var currentSelection;var isSelectionCheckPending;var isRequired;var inlineCss;var shortcutHandlers={};var autoExpandBounds;var autoExpandThrottle;var toolbarButtons={};var maximizeScrollPosition;var pasteContentFragment;var allEmoticons={};var icons;var init,replaceEmoticons,handleCommand,saveRange,initEditor,initPlugins,initLocale,initToolBar,initOptions,initEvents,initResize,initEmoticons,handlePasteEvt,handlePasteData,handleKeyDown,handleBackSpace,handleKeyPress,handleFormReset,handleMouseDown,handleComposition,handleEvent,handleDocumentClick,updateToolBar,updateActiveButtons,sourceEditorSelectedText,appendNewLine,checkSelectionChanged,checkNodeChanged,autofocus,emoticonsKeyPress,emoticonsCheckWhitespace,currentStyledBlockNode,triggerValueChanged,valueChangedBlur,valueChangedKeyUp,autoUpdate,autoExpand;base.commands=extend(true,{},userOptions.commands||defaultCmds);var options=base.opts=extend(true,{},defaultOptions,userOptions);base.opts.emoticons=userOptions.emoticons||defaultOptions.emoticons;init=function(){original._sceditor=base;if(options.locale&&options.locale!=="en"){initLocale()}editorContainer=createElement("div",{className:"sceditor-container"});insertBefore(editorContainer,original);css(editorContainer,"z-index",options.zIndex);if(IE_VER){addClass(editorContainer,"ie ie"+IE_VER)}isRequired=original.required;original.required=false;var FormatCtor=SCEditor.formats[options.format];format=FormatCtor?new FormatCtor:{};if("init"in format){format.init.call(base)}initPlugins();initEmoticons();initToolBar();initEditor();initOptions();initEvents();if(!isWysiwygSupported){base.toggleSourceMode()}updateActiveButtons();var loaded=function(){off(globalWin,"load",loaded);if(options.autofocus){autofocus()}autoExpand();appendNewLine();pluginManager.call("ready");if("onReady"in format){format.onReady.call(base)}};on(globalWin,"load",loaded);if(globalDoc.readyState==="complete"){loaded()}};initPlugins=function(){var plugins=options.plugins;plugins=plugins?plugins.toString().split(","):[];pluginManager=new PluginManager(base);plugins.forEach(function(plugin){pluginManager.register(plugin.trim())})};initLocale=function(){var lang;locale=SCEditor.locale[options.locale];if(!locale){lang=options.locale.split("-");locale=SCEditor.locale[lang[0]]}if(locale&&locale.dateFormat){options.dateFormat=locale.dateFormat}};initEditor=function(){sourceEditor=createElement("textarea");wysiwygEditor=createElement("iframe",{frameborder:0,allowfullscreen:true});if(options.startInSourceMode){addClass(editorContainer,"sourceMode");hide(wysiwygEditor)}else{addClass(editorContainer,"wysiwygMode");hide(sourceEditor)}if(!options.spellcheck){attr(editorContainer,"spellcheck","false")}if(globalWin.location.protocol==="https:"){attr(wysiwygEditor,"src","javascript:false")}appendChild(editorContainer,wysiwygEditor);appendChild(editorContainer,sourceEditor);base.dimensions(options.width||width(original),options.height||height(original));var className=IE_VER?"ie ie"+IE_VER:"";className+=ios?" ios":"";wysiwygDocument=wysiwygEditor.contentDocument;wysiwygDocument.open();wysiwygDocument.write(_tmpl("html",{attrs:' class="'+className+'"',spellcheck:options.spellcheck?"":'spellcheck="false"',charset:options.charset,style:options.style}));wysiwygDocument.close();wysiwygBody=wysiwygDocument.body;wysiwygWindow=wysiwygEditor.contentWindow;base.readOnly(!!options.readOnly);if(ios||edge||IE_VER){height(wysiwygBody,"100%");if(!IE_VER){on(wysiwygBody,"touchend",base.focus)}}var tabIndex=attr(original,"tabindex");attr(sourceEditor,"tabindex",tabIndex);attr(wysiwygEditor,"tabindex",tabIndex);rangeHelper=new RangeHelper(wysiwygWindow);hide(original);base.val(original.value);var placeholder=options.placeholder||attr(original,"placeholder");if(placeholder){sourceEditor.placeholder=placeholder;attr(wysiwygBody,"placeholder",placeholder)}};initOptions=function(){if(options.autoUpdate){on(wysiwygBody,"blur",autoUpdate);on(sourceEditor,"blur",autoUpdate)}if(options.rtl===null){options.rtl=css(sourceEditor,"direction")==="rtl"}base.rtl(!!options.rtl);if(options.autoExpand){on(wysiwygBody,"load",autoExpand,EVENT_CAPTURE);on(wysiwygBody,"input keyup",autoExpand)}if(options.resizeEnabled){initResize()}attr(editorContainer,"id",options.id);base.emoticons(options.emoticonsEnabled)};initEvents=function(){var form=original.form;var compositionEvents="compositionstart compositionend";var eventsToForward="keydown keyup keypress focus blur contextmenu";var checkSelectionEvents="onselectionchange"in wysiwygDocument?"selectionchange":"keyup focus blur contextmenu mouseup touchend click";on(globalDoc,"click",handleDocumentClick);if(form){on(form,"reset",handleFormReset);on(form,"submit",base.updateOriginal,EVENT_CAPTURE)}on(wysiwygBody,"keypress",handleKeyPress);on(wysiwygBody,"keydown",handleKeyDown);on(wysiwygBody,"keydown",handleBackSpace);on(wysiwygBody,"keyup",appendNewLine);on(wysiwygBody,"blur",valueChangedBlur);on(wysiwygBody,"keyup",valueChangedKeyUp);on(wysiwygBody,"paste",handlePasteEvt);on(wysiwygBody,compositionEvents,handleComposition);on(wysiwygBody,checkSelectionEvents,checkSelectionChanged);on(wysiwygBody,eventsToForward,handleEvent);if(options.emoticonsCompat&&globalWin.getSelection){on(wysiwygBody,"keyup",emoticonsCheckWhitespace)}on(wysiwygBody,"blur",function(){if(!base.val()){addClass(wysiwygBody,"placeholder")}});on(wysiwygBody,"focus",function(){removeClass(wysiwygBody,"placeholder")});on(sourceEditor,"blur",valueChangedBlur);on(sourceEditor,"keyup",valueChangedKeyUp);on(sourceEditor,"keydown",handleKeyDown);on(sourceEditor,compositionEvents,handleComposition);on(sourceEditor,eventsToForward,handleEvent);on(wysiwygDocument,"mousedown",handleMouseDown);on(wysiwygDocument,checkSelectionEvents,checkSelectionChanged);on(wysiwygDocument,"beforedeactivate keyup mouseup",saveRange);on(wysiwygDocument,"keyup",appendNewLine);on(wysiwygDocument,"focus",function(){lastRange=null});on(editorContainer,"selectionchanged",checkNodeChanged);on(editorContainer,"selectionchanged",updateActiveButtons);on(editorContainer,"selectionchanged valuechanged nodechanged pasteraw paste",handleEvent)};initToolBar=function(){var group,commands=base.commands,exclude=(options.toolbarExclude||"").split(","),groups=options.toolbar.split("|");toolbar=createElement("div",{className:"sceditor-toolbar",unselectable:"on"});if(options.icons in SCEditor.icons){icons=new SCEditor.icons[options.icons]}each(groups,function(_,menuItems){group=createElement("div",{className:"sceditor-group"});each(menuItems.split(","),function(_,commandName){var button,shortcut,command=commands[commandName];if(!command||exclude.indexOf(commandName)>-1){return}shortcut=command.shortcut;button=_tmpl("toolbarButton",{name:commandName,dispName:base._(command.name||command.tooltip||commandName)},true).firstChild;if(icons&&icons.create){var icon=icons.create(commandName);if(icon){insertBefore(icons.create(commandName),button.firstChild);addClass(button,"has-icon")}}button._sceTxtMode=!!command.txtExec;button._sceWysiwygMode=!!command.exec;toggleClass(button,"disabled",!command.exec);on(button,"click",function(e){if(!hasClass(button,"disabled")){handleCommand(button,command)}updateActiveButtons();e.preventDefault()});on(button,"mousedown",function(e){base.closeDropDown();e.preventDefault()});if(command.tooltip){attr(button,"title",base._(command.tooltip)+(shortcut?" ("+shortcut+")":""))}if(shortcut){base.addShortcut(shortcut,commandName)}if(command.state){btnStateHandlers.push({name:commandName,state:command.state})}else if(isString(command.exec)){btnStateHandlers.push({name:commandName,state:command.exec})}appendChild(group,button);toolbarButtons[commandName]=button});if(group.firstChild){appendChild(toolbar,group)}});appendChild(options.toolbarContainer||editorContainer,toolbar)};initResize=function(){var minHeight,maxHeight,minWidth,maxWidth,mouseMoveFunc,mouseUpFunc,grip=createElement("div",{className:"sceditor-grip"}),cover=createElement("div",{className:"sceditor-resize-cover"}),moveEvents="touchmove mousemove",endEvents="touchcancel touchend mouseup",startX=0,startY=0,newX=0,newY=0,startWidth=0,startHeight=0,origWidth=width(editorContainer),origHeight=height(editorContainer),isDragging=false,rtl=base.rtl();minHeight=options.resizeMinHeight||origHeight/1.5;maxHeight=options.resizeMaxHeight||origHeight*2.5;minWidth=options.resizeMinWidth||origWidth/1.25;maxWidth=options.resizeMaxWidth||origWidth*1.25;mouseMoveFunc=function(e){if(e.type==="touchmove"){e=globalWin.event;newX=e.changedTouches[0].pageX;newY=e.changedTouches[0].pageY}else{newX=e.pageX;newY=e.pageY}var newHeight=startHeight+(newY-startY),newWidth=rtl?startWidth-(newX-startX):startWidth+(newX-startX);if(maxWidth>0&&newWidth>maxWidth){newWidth=maxWidth}if(minWidth>0&&newWidth<minWidth){newWidth=minWidth}if(!options.resizeWidth){newWidth=false}if(maxHeight>0&&newHeight>maxHeight){newHeight=maxHeight}if(minHeight>0&&newHeight<minHeight){newHeight=minHeight}if(!options.resizeHeight){newHeight=false}if(newWidth||newHeight){base.dimensions(newWidth,newHeight)}e.preventDefault()};mouseUpFunc=function(e){if(!isDragging){return}isDragging=false;hide(cover);removeClass(editorContainer,"resizing");off(globalDoc,moveEvents,mouseMoveFunc);off(globalDoc,endEvents,mouseUpFunc);e.preventDefault()};if(icons&&icons.create){var icon=icons.create("grip");if(icon){appendChild(grip,icon);addClass(grip,"has-icon")}}appendChild(editorContainer,grip);appendChild(editorContainer,cover);hide(cover);on(grip,"touchstart mousedown",function(e){if(e.type==="touchstart"){e=globalWin.event;startX=e.touches[0].pageX;startY=e.touches[0].pageY}else{startX=e.pageX;startY=e.pageY}startWidth=width(editorContainer);startHeight=height(editorContainer);isDragging=true;addClass(editorContainer,"resizing");show(cover);on(globalDoc,moveEvents,mouseMoveFunc);on(globalDoc,endEvents,mouseUpFunc);e.preventDefault()})};initEmoticons=function(){var emoticons=options.emoticons;var root=options.emoticonsRoot||"";if(emoticons){allEmoticons=extend({},emoticons.more,emoticons.dropdown,emoticons.hidden)}each(allEmoticons,function(key,url){allEmoticons[key]=_tmpl("emoticon",{key:key,url:root+(url.url||url),tooltip:url.tooltip||key});if(options.emoticonsEnabled){preLoadCache.push(createElement("img",{src:root+(url.url||url)}))}})};autofocus=function(){var range,txtPos,node=wysiwygBody.firstChild,focusEnd=!!options.autofocusEnd;if(!isVisible(editorContainer)){return}if(base.sourceMode()){txtPos=focusEnd?sourceEditor.value.length:0;sourceEditor.setSelectionRange(txtPos,txtPos);return}removeWhiteSpace(wysiwygBody);if(focusEnd){if(!(node=wysiwygBody.lastChild)){node=createElement("p",{},wysiwygDocument);appendChild(wysiwygBody,node)}while(node.lastChild){node=node.lastChild;if(!IE_BR_FIX$2&&is(node,"br")&&node.previousSibling){node=node.previousSibling}}}range=wysiwygDocument.createRange();if(!canHaveChildren(node)){range.setStartBefore(node);if(focusEnd){range.setStartAfter(node)}}else{range.selectNodeContents(node)}range.collapse(!focusEnd);rangeHelper.selectRange(range);currentSelection=range;if(focusEnd){wysiwygBody.scrollTop=wysiwygBody.scrollHeight}base.focus()};base.readOnly=function(readOnly){if(typeof readOnly!=="boolean"){return!sourceEditor.readonly}wysiwygBody.contentEditable=!readOnly;sourceEditor.readonly=!readOnly;updateToolBar(readOnly);return base};base.rtl=function(rtl){var dir=rtl?"rtl":"ltr";if(typeof rtl!=="boolean"){return attr(sourceEditor,"dir")==="rtl"}attr(wysiwygBody,"dir",dir);attr(sourceEditor,"dir",dir);removeClass(editorContainer,"rtl");removeClass(editorContainer,"ltr");addClass(editorContainer,dir);if(icons&&icons.rtl){icons.rtl(rtl)}return base};updateToolBar=function(disable){var mode=base.inSourceMode()?"_sceTxtMode":"_sceWysiwygMode";each(toolbarButtons,function(_,button){toggleClass(button,"disabled",disable||!button[mode])})};base.width=function(width$$1,saveWidth){if(!width$$1&&width$$1!==0){return width(editorContainer)}base.dimensions(width$$1,null,saveWidth);return base};base.dimensions=function(width$$1,height$$1,save){width$$1=!width$$1&&width$$1!==0?false:width$$1;height$$1=!height$$1&&height$$1!==0?false:height$$1;if(width$$1===false&&height$$1===false){return{width:base.width(),height:base.height()}}if(width$$1!==false){if(save!==false){options.width=width$$1}width(editorContainer,width$$1)}if(height$$1!==false){if(save!==false){options.height=height$$1}height(editorContainer,height$$1)}return base};base.height=function(height$$1,saveHeight){if(!height$$1&&height$$1!==0){return height(editorContainer)}base.dimensions(null,height$$1,saveHeight);return base};base.maximize=function(maximize){var maximizeSize="sceditor-maximize";if(isUndefined(maximize)){return hasClass(editorContainer,maximizeSize)}maximize=!!maximize;if(maximize){maximizeScrollPosition=globalWin.pageYOffset}toggleClass(globalDoc.documentElement,maximizeSize,maximize);toggleClass(globalDoc.body,maximizeSize,maximize);toggleClass(editorContainer,maximizeSize,maximize);base.width(maximize?"100%":options.width,false);base.height(maximize?"100%":options.height,false);if(!maximize){globalWin.scrollTo(0,maximizeScrollPosition)}autoExpand();return base};autoExpand=function(){if(options.autoExpand&&!autoExpandThrottle){autoExpandThrottle=setTimeout(base.expandToContent,200)}};base.expandToContent=function(ignoreMaxHeight){if(base.maximize()){return}clearTimeout(autoExpandThrottle);autoExpandThrottle=false;if(!autoExpandBounds){var height$$1=options.resizeMinHeight||options.height||height(original);autoExpandBounds={min:height$$1,max:options.resizeMaxHeight||height$$1*2}}var range=globalDoc.createRange();range.selectNodeContents(wysiwygBody);var rect=range.getBoundingClientRect();var current=wysiwygDocument.documentElement.clientHeight-1;var spaceNeeded=rect.bottom-rect.top;var newHeight=base.height()+1+(spaceNeeded-current);if(!ignoreMaxHeight&&autoExpandBounds.max!==-1){newHeight=Math.min(newHeight,autoExpandBounds.max)}base.height(Math.ceil(Math.max(newHeight,autoExpandBounds.min)))};base.destroy=function(){if(!pluginManager){return}pluginManager.destroy();rangeHelper=null;lastRange=null;pluginManager=null;if(dropdown){remove(dropdown)}off(globalDoc,"click",handleDocumentClick);var form=original.form;if(form){off(form,"reset",handleFormReset);off(form,"submit",base.updateOriginal)}remove(sourceEditor);remove(toolbar);remove(editorContainer);delete original._sceditor;show(original);original.required=isRequired};base.createDropDown=function(menuItem,name,content,ieFix){var dropDownCss,dropDownClass="sceditor-"+name;base.closeDropDown(true);if(dropdown&&hasClass(dropdown,dropDownClass)){return}if(ieFix!==false){each(find(content,":not(input):not(textarea)"),function(_,node){if(node.nodeType===ELEMENT_NODE){attr(node,"unselectable","on")}})}dropDownCss=extend({top:menuItem.offsetTop,left:menuItem.offsetLeft,marginTop:menuItem.clientHeight},options.dropDownCss);dropdown=createElement("div",{className:"sceditor-dropdown "+dropDownClass});css(dropdown,dropDownCss);appendChild(dropdown,content);appendChild(editorContainer,dropdown);on(dropdown,"click focusin",function(e){e.stopPropagation()});setTimeout(function(){if(dropdown){var first=find(dropdown,"input,textarea")[0];if(first){first.focus()}}})};handleDocumentClick=function(e){if(e.which!==3&&dropdown&&!e.defaultPrevented){autoUpdate();base.closeDropDown()}};handlePasteEvt=function(e){var isIeOrEdge=IE_VER||edge;var editable=wysiwygBody;var clipboard=e.clipboardData;var loadImage=function(file){var reader=new FileReader;reader.onload=function(e){handlePasteData({html:'<img src="'+e.target.result+'" />'})};reader.readAsDataURL(file)};if(clipboard&&!isIeOrEdge){var data$$1={};var types=clipboard.types;var items=clipboard.items;e.preventDefault();for(var i=0;i<types.length;i++){if(globalWin.FileReader&&items&&IMAGE_MIME_REGEX.test(items[i].type)){return loadImage(clipboard.items[i].getAsFile())}data$$1[types[i]]=clipboard.getData(types[i])}data$$1.text=data$$1["text/plain"];data$$1.html=data$$1["text/html"];handlePasteData(data$$1)}else if(!pasteContentFragment){var scrollTop=editable.scrollTop;rangeHelper.saveRange();pasteContentFragment=globalDoc.createDocumentFragment();while(editable.firstChild){appendChild(pasteContentFragment,editable.firstChild)}setTimeout(function(){var html=editable.innerHTML;editable.innerHTML="";appendChild(editable,pasteContentFragment);editable.scrollTop=scrollTop;pasteContentFragment=false;rangeHelper.restoreRange();handlePasteData({html:html})},0)}};handlePasteData=function(data$$1){var pasteArea=createElement("div",{},wysiwygDocument);pluginManager.call("pasteRaw",data$$1);trigger(editorContainer,"pasteraw",data$$1);if(data$$1.html){pasteArea.innerHTML=data$$1.html;fixNesting(pasteArea)}else{pasteArea.innerHTML=entities(data$$1.text||"")}var paste={val:pasteArea.innerHTML};if("fragmentToSource"in format){paste.val=format.fragmentToSource(paste.val,wysiwygDocument,currentNode)}pluginManager.call("paste",paste);trigger(editorContainer,"paste",paste);if("fragmentToHtml"in format){paste.val=format.fragmentToHtml(paste.val,currentNode)}pluginManager.call("pasteHtml",paste);base.wysiwygEditorInsertHtml(paste.val,null,true)};base.closeDropDown=function(focus){if(dropdown){remove(dropdown);dropdown=null}if(focus===true){base.focus()}};base.wysiwygEditorInsertHtml=function(html,endHtml,overrideCodeBlocking){var marker,scrollTop,scrollTo,editorHeight=height(wysiwygEditor);base.focus();if(!overrideCodeBlocking&&closest(currentBlockNode,"code")){return}rangeHelper.insertHTML(html,endHtml);rangeHelper.saveRange();replaceEmoticons();marker=find(wysiwygBody,"#sceditor-end-marker")[0];show(marker);scrollTop=wysiwygBody.scrollTop;scrollTo=getOffset(marker).top+marker.offsetHeight*1.5-editorHeight;hide(marker);if(scrollTo>scrollTop||scrollTo+editorHeight<scrollTop){wysiwygBody.scrollTop=scrollTo}triggerValueChanged(false);rangeHelper.restoreRange();appendNewLine()};base.wysiwygEditorInsertText=function(text,endText){base.wysiwygEditorInsertHtml(entities(text),entities(endText))};base.insertText=function(text,endText){if(base.inSourceMode()){base.sourceEditorInsertText(text,endText)}else{base.wysiwygEditorInsertText(text,endText)}return base};base.sourceEditorInsertText=function(text,endText){var scrollTop,currentValue,startPos=sourceEditor.selectionStart,endPos=sourceEditor.selectionEnd;scrollTop=sourceEditor.scrollTop;sourceEditor.focus();currentValue=sourceEditor.value;if(endText){text+=currentValue.substring(startPos,endPos)+endText}sourceEditor.value=currentValue.substring(0,startPos)+text+currentValue.substring(endPos,currentValue.length);sourceEditor.selectionStart=startPos+text.length-(endText?endText.length:0);sourceEditor.selectionEnd=sourceEditor.selectionStart;sourceEditor.scrollTop=scrollTop;sourceEditor.focus();triggerValueChanged()};base.getRangeHelper=function(){return rangeHelper};base.sourceEditorCaret=function(position){sourceEditor.focus();if(position){sourceEditor.selectionStart=position.start;sourceEditor.selectionEnd=position.end;return this}return{start:sourceEditor.selectionStart,end:sourceEditor.selectionEnd}};base.val=function(val,filter){if(!isString(val)){return base.inSourceMode()?base.getSourceEditorValue(false):base.getWysiwygEditorValue(filter)}if(!base.inSourceMode()){if(filter!==false&&"toHtml"in format){val=format.toHtml(val)}base.setWysiwygEditorValue(val)}else{base.setSourceEditorValue(val)}return base};base.insert=function(start,end,filter,convertEmoticons,allowMixed){if(base.inSourceMode()){base.sourceEditorInsertText(start,end);return base}if(end){var html=rangeHelper.selectedHtml();if(filter!==false&&"fragmentToSource"in format){html=format.fragmentToSource(html,wysiwygDocument,currentNode)}start+=html+end}if(filter!==false&&"fragmentToHtml"in format){start=format.fragmentToHtml(start,currentNode)}if(filter!==false&&allowMixed===true){start=start.replace(/&lt;/g,"<").replace(/&gt;/g,">").replace(/&amp;/g,"&")}base.wysiwygEditorInsertHtml(start);return base};base.getWysiwygEditorValue=function(filter){var html;var tmp=createElement("div",{},wysiwygDocument);var childNodes=wysiwygBody.childNodes;for(var i=0;i<childNodes.length;i++){appendChild(tmp,childNodes[i].cloneNode(true))}appendChild(wysiwygBody,tmp);fixNesting(tmp);remove(tmp);html=tmp.innerHTML;if(filter!==false&&format.hasOwnProperty("toSource")){html=format.toSource(html,wysiwygDocument)}return html};base.getBody=function(){return wysiwygBody};base.getContentAreaContainer=function(){return wysiwygEditor};base.getSourceEditorValue=function(filter){var val=sourceEditor.value;if(filter!==false&&"toHtml"in format){val=format.toHtml(val)}return val};base.setWysiwygEditorValue=function(value){if(!value){value="<p>"+(IE_VER?"":"<br />")+"</p>"}wysiwygBody.innerHTML=value;replaceEmoticons();appendNewLine();triggerValueChanged();autoExpand()};base.setSourceEditorValue=function(value){sourceEditor.value=value;triggerValueChanged()};base.updateOriginal=function(){original.value=base.val()};replaceEmoticons=function(){if(options.emoticonsEnabled){replace(wysiwygBody,allEmoticons,options.emoticonsCompat)}};base.inSourceMode=function(){return hasClass(editorContainer,"sourceMode")};base.sourceMode=function(enable){var inSourceMode=base.inSourceMode();if(typeof enable!=="boolean"){return inSourceMode}if(inSourceMode&&!enable||!inSourceMode&&enable){base.toggleSourceMode()}return base};base.toggleSourceMode=function(){var isInSourceMode=base.inSourceMode();if(!isWysiwygSupported&&isInSourceMode){return}if(!isInSourceMode){rangeHelper.saveRange();rangeHelper.clear()}base.blur();if(isInSourceMode){base.setWysiwygEditorValue(base.getSourceEditorValue())}else{base.setSourceEditorValue(base.getWysiwygEditorValue())}lastRange=null;toggle(sourceEditor);toggle(wysiwygEditor);toggleClass(editorContainer,"wysiwygMode",isInSourceMode);toggleClass(editorContainer,"sourceMode",!isInSourceMode);updateToolBar();updateActiveButtons()};sourceEditorSelectedText=function(){sourceEditor.focus();return sourceEditor.value.substring(sourceEditor.selectionStart,sourceEditor.selectionEnd)};handleCommand=function(caller,cmd){if(base.inSourceMode()){if(cmd.txtExec){if(Array.isArray(cmd.txtExec)){base.sourceEditorInsertText.apply(base,cmd.txtExec)}else{cmd.txtExec.call(base,caller,sourceEditorSelectedText())}}}else if(cmd.exec){if(isFunction(cmd.exec)){cmd.exec.call(base,caller)}else{base.execCommand(cmd.exec,cmd.hasOwnProperty("execParam")?cmd.execParam:null)}}};saveRange=function(){if(IE_VER){lastRange=rangeHelper.selectedRange()}};base.execCommand=function(command,param){var executed=false,commandObj=base.commands[command];base.focus();if(closest(rangeHelper.parentNode(),"code")){return}try{executed=wysiwygDocument.execCommand(command,false,param)}catch(ex){}if(!executed&&commandObj&&commandObj.errorMessage){alert(base._(commandObj.errorMessage))}updateActiveButtons()};checkSelectionChanged=function(){function check(){if(wysiwygWindow.getSelection()&&wysiwygWindow.getSelection().rangeCount<=0){currentSelection=null}else if(rangeHelper&&!rangeHelper.compare(currentSelection)){currentSelection=rangeHelper.cloneSelected();if(currentSelection&&currentSelection.collapsed){var parent$$1=currentSelection.startContainer;var offset=currentSelection.startOffset;if(offset&&parent$$1.nodeType!==TEXT_NODE){parent$$1=parent$$1.childNodes[offset]}while(parent$$1&&parent$$1.parentNode!==wysiwygBody){parent$$1=parent$$1.parentNode}if(parent$$1&&isInline(parent$$1,true)){rangeHelper.saveRange();wrapInlines(wysiwygBody,wysiwygDocument);rangeHelper.restoreRange()}}trigger(editorContainer,"selectionchanged")}isSelectionCheckPending=false}if(isSelectionCheckPending){return}isSelectionCheckPending=true;if("onselectionchange"in wysiwygDocument){check()}else{setTimeout(check,100)}};checkNodeChanged=function(){var oldNode,node=rangeHelper.parentNode();if(currentNode!==node){oldNode=currentNode;currentNode=node;currentBlockNode=rangeHelper.getFirstBlockParent(node);trigger(editorContainer,"nodechanged",{oldNode:oldNode,newNode:currentNode})}};base.currentNode=function(){return currentNode};base.currentBlockNode=function(){return currentBlockNode};updateActiveButtons=function(){var firstBlock,parent$$1;var activeClass="active";var doc=wysiwygDocument;var isSource=base.sourceMode();if(base.readOnly()){each(find(toolbar,activeClass),function(_,menuItem){removeClass(menuItem,activeClass)});return}if(!isSource){parent$$1=rangeHelper.parentNode();firstBlock=rangeHelper.getFirstBlockParent(parent$$1)}for(var j=0;j<btnStateHandlers.length;j++){var state=0;var btn=toolbarButtons[btnStateHandlers[j].name];var stateFn=btnStateHandlers[j].state;var isDisabled=isSource&&!btn._sceTxtMode||!isSource&&!btn._sceWysiwygMode;if(isString(stateFn)){if(!isSource){try{state=doc.queryCommandEnabled(stateFn)?0:-1;if(state>-1){state=doc.queryCommandState(stateFn)?1:0}}catch(ex){}}}else if(!isDisabled){state=stateFn.call(base,parent$$1,firstBlock)}toggleClass(btn,"disabled",isDisabled||state<0);toggleClass(btn,activeClass,state>0)}if(icons&&icons.update){icons.update(isSource,parent$$1,firstBlock)}};handleKeyPress=function(e){if(e.defaultPrevented){return}base.closeDropDown();if(e.which===13){var LIST_TAGS="li,ul,ol";if(!is(currentBlockNode,LIST_TAGS)&&hasStyling(currentBlockNode)){lastRange=null;var br=createElement("br",{},wysiwygDocument);rangeHelper.insertNode(br);if(!IE_BR_FIX$2){var parent$$1=br.parentNode;var lastChild=parent$$1.lastChild;if(lastChild&&lastChild.nodeType===TEXT_NODE&&lastChild.nodeValue===""){remove(lastChild);lastChild=parent$$1.lastChild}if(!isInline(parent$$1,true)&&lastChild===br&&isInline(br.previousSibling)){rangeHelper.insertHTML("<br>")}}e.preventDefault()}}};appendNewLine=function(){rTraverse(wysiwygBody,function(node){if(node.nodeType===ELEMENT_NODE&&!/inline/.test(css(node,"display"))){if(!is(node,".sceditor-nlf")&&hasStyling(node)){var paragraph=createElement("p",{},wysiwygDocument);paragraph.className="sceditor-nlf";paragraph.innerHTML=!IE_BR_FIX$2?"<br />":"";appendChild(wysiwygBody,paragraph);return false}}if(node.nodeType===3&&!/^\s*$/.test(node.nodeValue)||is(node,"br")){return false}})};handleFormReset=function(){base.val(original.value)};handleMouseDown=function(){base.closeDropDown();lastRange=null};base._=function(){var undef,args=arguments;if(locale&&locale[args[0]]){args[0]=locale[args[0]]}return args[0].replace(/\{(\d+)\}/g,function(str,p1){return args[p1-0+1]!==undef?args[p1-0+1]:"{"+p1+"}"})};handleEvent=function(e){if(pluginManager){pluginManager.call(e.type+"Event",e,base)}var name=(e.target===sourceEditor?"scesrc":"scewys")+e.type;if(eventHandlers[name]){eventHandlers[name].forEach(function(fn){fn.call(base,e)})}};base.bind=function(events,handler,excludeWysiwyg,excludeSource){events=events.split(" ");var i=events.length;while(i--){if(isFunction(handler)){var wysEvent="scewys"+events[i];var srcEvent="scesrc"+events[i];if(!excludeWysiwyg){eventHandlers[wysEvent]=eventHandlers[wysEvent]||[];eventHandlers[wysEvent].push(handler)}if(!excludeSource){eventHandlers[srcEvent]=eventHandlers[srcEvent]||[];eventHandlers[srcEvent].push(handler)}if(events[i]==="valuechanged"){triggerValueChanged.hasHandler=true}}}return base};base.unbind=function(events,handler,excludeWysiwyg,excludeSource){events=events.split(" ");var i=events.length;while(i--){if(isFunction(handler)){if(!excludeWysiwyg){arrayRemove(eventHandlers["scewys"+events[i]]||[],handler)}if(!excludeSource){arrayRemove(eventHandlers["scesrc"+events[i]]||[],handler)}}}return base};base.blur=function(handler,excludeWysiwyg,excludeSource){if(isFunction(handler)){base.bind("blur",handler,excludeWysiwyg,excludeSource)}else if(!base.sourceMode()){wysiwygBody.blur()}else{sourceEditor.blur()}return base};base.focus=function(handler,excludeWysiwyg,excludeSource){if(isFunction(handler)){base.bind("focus",handler,excludeWysiwyg,excludeSource)}else if(!base.inSourceMode()){if(find(wysiwygDocument,":focus").length){return}var container;var rng=rangeHelper.selectedRange();if(!currentSelection){autofocus()}if(!IE_BR_FIX$2&&rng&&rng.endOffset===1&&rng.collapsed){container=rng.endContainer;if(container&&container.childNodes.length===1&&is(container.firstChild,"br")){rng.setStartBefore(container.firstChild);rng.collapse(true);rangeHelper.selectRange(rng)}}wysiwygWindow.focus();wysiwygBody.focus();if(lastRange){rangeHelper.selectRange(lastRange);lastRange=null}}else{sourceEditor.focus()}updateActiveButtons();return base};base.keyDown=function(handler,excludeWysiwyg,excludeSource){return base.bind("keydown",handler,excludeWysiwyg,excludeSource)};base.keyPress=function(handler,excludeWysiwyg,excludeSource){return base.bind("keypress",handler,excludeWysiwyg,excludeSource)};base.keyUp=function(handler,excludeWysiwyg,excludeSource){return base.bind("keyup",handler,excludeWysiwyg,excludeSource)};base.nodeChanged=function(handler){return base.bind("nodechanged",handler,false,true)};base.selectionChanged=function(handler){return base.bind("selectionchanged",handler,false,true)};base.valueChanged=function(handler,excludeWysiwyg,excludeSource){return base.bind("valuechanged",handler,excludeWysiwyg,excludeSource)};emoticonsKeyPress=function(e){var replacedEmoticon,cachePos=0,emoticonsCache=base.emoticonsCache,curChar=String.fromCharCode(e.which);if(closest(currentBlockNode,"code")){return}if(!emoticonsCache){emoticonsCache=[];each(allEmoticons,function(key,html){emoticonsCache[cachePos++]=[key,html]});emoticonsCache.sort(function(a,b){return a[0].length-b[0].length});base.emoticonsCache=emoticonsCache;base.longestEmoticonCode=emoticonsCache[emoticonsCache.length-1][0].length}replacedEmoticon=rangeHelper.replaceKeyword(base.emoticonsCache,true,true,base.longestEmoticonCode,options.emoticonsCompat,curChar);if(replacedEmoticon){if(!options.emoticonsCompat||!/^\s$/.test(curChar)){e.preventDefault()}}};emoticonsCheckWhitespace=function(){checkWhitespace(currentBlockNode,rangeHelper)};base.emoticons=function(enable){if(!enable&&enable!==false){return options.emoticonsEnabled}options.emoticonsEnabled=enable;if(enable){on(wysiwygBody,"keypress",emoticonsKeyPress);if(!base.sourceMode()){rangeHelper.saveRange();replaceEmoticons();triggerValueChanged(false);rangeHelper.restoreRange()}}else{var emoticons=find(wysiwygBody,"img[data-sceditor-emoticon]");each(emoticons,function(_,img){var text=data(img,"sceditor-emoticon");var textNode=wysiwygDocument.createTextNode(text);img.parentNode.replaceChild(textNode,img)});off(wysiwygBody,"keypress",emoticonsKeyPress);triggerValueChanged()}return base};base.css=function(css$$1){if(!inlineCss){inlineCss=createElement("style",{id:"inline"},wysiwygDocument);appendChild(wysiwygDocument.head,inlineCss)}if(!isString(css$$1)){return inlineCss.styleSheet?inlineCss.styleSheet.cssText:inlineCss.innerHTML}if(inlineCss.styleSheet){inlineCss.styleSheet.cssText=css$$1}else{inlineCss.innerHTML=css$$1}return base};handleKeyDown=function(e){var shortcut=[],SHIFT_KEYS={"`":"~",1:"!",2:"@",3:"#",4:"$",5:"%",6:"^",7:"&",8:"*",9:"(",0:")","-":"_","=":"+",";":": ","'":'"',",":"<",".":">","/":"?","\\":"|","[":"{","]":"}"},SPECIAL_KEYS={8:"backspace",9:"tab",13:"enter",19:"pause",20:"capslock",27:"esc",32:"space",33:"pageup",34:"pagedown",35:"end",36:"home",37:"left",38:"up",39:"right",40:"down",45:"insert",46:"del",91:"win",92:"win",93:"select",96:"0",97:"1",98:"2",99:"3",100:"4",101:"5",102:"6",103:"7",104:"8",105:"9",106:"*",107:"+",109:"-",110:".",111:"/",112:"f1",113:"f2",114:"f3",115:"f4",116:"f5",117:"f6",118:"f7",119:"f8",120:"f9",121:"f10",122:"f11",123:"f12",144:"numlock",145:"scrolllock",186:";",187:"=",188:",",189:"-",190:".",191:"/",192:"`",219:"[",220:"\\",221:"]",222:"'"},NUMPAD_SHIFT_KEYS={109:"-",110:"del",111:"/",96:"0",97:"1",98:"2",99:"3",100:"4",101:"5",102:"6",103:"7",104:"8",105:"9"},which=e.which,character=SPECIAL_KEYS[which]||String.fromCharCode(which).toLowerCase();if(e.ctrlKey||e.metaKey){shortcut.push("ctrl")}if(e.altKey){shortcut.push("alt")}if(e.shiftKey){shortcut.push("shift");if(NUMPAD_SHIFT_KEYS[which]){character=NUMPAD_SHIFT_KEYS[which]}else if(SHIFT_KEYS[character]){character=SHIFT_KEYS[character]}}if(character&&(which<16||which>18)){shortcut.push(character)}shortcut=shortcut.join("+");if(shortcutHandlers[shortcut]&&shortcutHandlers[shortcut].call(base)===false){e.stopPropagation();e.preventDefault()}};base.addShortcut=function(shortcut,cmd){shortcut=shortcut.toLowerCase();if(isString(cmd)){shortcutHandlers[shortcut]=function(){handleCommand(toolbarButtons[cmd],base.commands[cmd]);return false}}else{shortcutHandlers[shortcut]=cmd}return base};base.removeShortcut=function(shortcut){delete shortcutHandlers[shortcut.toLowerCase()];return base};handleBackSpace=function(e){var node,offset,range,parent$$1;if(options.disableBlockRemove||e.which!==8||!(range=rangeHelper.selectedRange())){return}node=range.startContainer;offset=range.startOffset;if(offset!==0||!(parent$$1=currentStyledBlockNode())||is(parent$$1,"body")){return}while(node!==parent$$1){while(node.previousSibling){node=node.previousSibling;if(node.nodeType!==TEXT_NODE||node.nodeValue){return}}if(!(node=node.parentNode)){return}}base.clearBlockFormatting(parent$$1);e.preventDefault()};currentStyledBlockNode=function(){var block=currentBlockNode;while(!hasStyling(block)||isInline(block,true)){if(!(block=block.parentNode)||is(block,"body")){return}}return block};base.clearBlockFormatting=function(block){block=block||currentStyledBlockNode();if(!block||is(block,"body")){return base}rangeHelper.saveRange();block.className="";lastRange=null;attr(block,"style","");if(!is(block,"p,div,td")){convertElement(block,"p")}rangeHelper.restoreRange();return base};triggerValueChanged=function(saveRange){if(!pluginManager||!pluginManager.hasHandler("valuechangedEvent")&&!triggerValueChanged.hasHandler){return}var currentHtml,sourceMode=base.sourceMode(),hasSelection=!sourceMode&&rangeHelper.hasSelection();isComposing=false;saveRange=saveRange!==false&&!wysiwygDocument.getElementById("sceditor-start-marker");if(valueChangedKeyUpTimer){clearTimeout(valueChangedKeyUpTimer);valueChangedKeyUpTimer=false}if(hasSelection&&saveRange){rangeHelper.saveRange()}currentHtml=sourceMode?sourceEditor.value:wysiwygBody.innerHTML;if(currentHtml!==triggerValueChanged.lastVal){triggerValueChanged.lastVal=currentHtml;trigger(editorContainer,"valuechanged",{rawValue:sourceMode?base.val():currentHtml})}if(hasSelection&&saveRange){rangeHelper.removeMarkers()}};valueChangedBlur=function(){if(valueChangedKeyUpTimer){triggerValueChanged()}};valueChangedKeyUp=function(e){var which=e.which,lastChar=valueChangedKeyUp.lastChar,lastWasSpace=lastChar===13||lastChar===32,lastWasDelete=lastChar===8||lastChar===46;valueChangedKeyUp.lastChar=which;if(isComposing){return}if(which===13||which===32){if(!lastWasSpace){triggerValueChanged()}else{valueChangedKeyUp.triggerNext=true}}else if(which===8||which===46){if(!lastWasDelete){triggerValueChanged()}else{valueChangedKeyUp.triggerNext=true}}else if(valueChangedKeyUp.triggerNext){triggerValueChanged();valueChangedKeyUp.triggerNext=false}clearTimeout(valueChangedKeyUpTimer);valueChangedKeyUpTimer=setTimeout(function(){if(!isComposing){triggerValueChanged()}},1500)};handleComposition=function(e){isComposing=/start/i.test(e.type);if(!isComposing){triggerValueChanged()}};autoUpdate=function(){base.updateOriginal()};init()}SCEditor.locale={};SCEditor.formats={};SCEditor.icons={};SCEditor.command={get:function(name){return defaultCmds[name]||null},set:function(name,cmd){if(!name||!cmd){return false}cmd=extend(defaultCmds[name]||{},cmd);cmd.remove=function(){SCEditor.command.remove(name)};defaultCmds[name]=cmd;return this},remove:function(name){if(defaultCmds[name]){delete defaultCmds[name]}return this}};window.sceditor={command:SCEditor.command,commands:defaultCmds,defaultOptions:defaultOptions,ie:ie,ios:ios,isWysiwygSupported:isWysiwygSupported,regexEscape:regex,escapeEntities:entities,escapeUriScheme:uriScheme,dom:{css:css,attr:attr,removeAttr:removeAttr,is:is,closest:closest,width:width,height:height,traverse:traverse,rTraverse:rTraverse,parseHTML:parseHTML,hasStyling:hasStyling,convertElement:convertElement,blockLevelList:blockLevelList,canHaveChildren:canHaveChildren,isInline:isInline,copyCSS:copyCSS,fixNesting:fixNesting,findCommonAncestor:findCommonAncestor,getSibling:getSibling,removeWhiteSpace:removeWhiteSpace,extractContents:extractContents,getOffset:getOffset,getStyle:getStyle,hasStyle:hasStyle},locale:SCEditor.locale,icons:SCEditor.icons,utils:{each:each,isEmptyObject:isEmptyObject,extend:extend},plugins:PluginManager.plugins,formats:SCEditor.formats,create:function(textarea,options){options=options||{};if(parent(textarea,".sceditor-container")){return}if(options.runWithoutWysiwygSupport||isWysiwygSupported){new SCEditor(textarea,options)}},instance:function(textarea){return textarea._sceditor}};$.sceditor=window.sceditor;$.fn.sceditor=function(options){var instance;var ret=[];this.each(function(){instance=this._sceditor;if(options==="state"){ret.push(!!instance)}else if(options==="instance"){ret.push(instance)}else if(!instance){$.sceditor.create(this,options)}});if(!ret.length){return this}return ret.length===1?ret[0]:ret}})(jQuery);(function(sceditor){"use strict";var escapeEntities=sceditor.escapeEntities;var escapeUriScheme=sceditor.escapeUriScheme;var dom=sceditor.dom;var utils=sceditor.utils;var css=dom.css;var attr=dom.attr;var is=dom.is;var extend=utils.extend;var each=utils.each;var IE_VER=sceditor.ie;var IE_BR_FIX=IE_VER&&IE_VER<11;var EMOTICON_DATA_ATTR="data-sceditor-emoticon";var getEditorCommand=sceditor.command.get;var QuoteType={always:1,never:2,auto:3};var defaultCommandsOverrides={bold:{txtExec:["[b]","[/b]"]},italic:{txtExec:["[i]","[/i]"]},underline:{txtExec:["[u]","[/u]"]},strike:{txtExec:["[s]","[/s]"]},subscript:{txtExec:["[sub]","[/sub]"]},superscript:{txtExec:["[sup]","[/sup]"]},left:{txtExec:["[left]","[/left]"]},center:{txtExec:["[center]","[/center]"]},right:{txtExec:["[right]","[/right]"]},justify:{txtExec:["[justify]","[/justify]"]},font:{txtExec:function(caller){var editor=this;getEditorCommand("font")._dropDown(editor,caller,function(fontName){editor.insertText("[font="+fontName+"]","[/font]")})}},size:{txtExec:function(caller){var editor=this;getEditorCommand("size")._dropDown(editor,caller,function(fontSize){editor.insertText("[size="+fontSize+"]","[/size]")})}},color:{txtExec:function(caller){var editor=this;getEditorCommand("color")._dropDown(editor,caller,function(color){editor.insertText("[color="+color+"]","[/color]")})}},bulletlist:{txtExec:function(caller,selected){var content="";each(selected.split(/\r?\n/),function(){content+=(content?"\n":"")+"[li]"+this+"[/li]"});this.insertText("[ul]\n"+content+"\n[/ul]")}},orderedlist:{txtExec:function(caller,selected){var content="";each(selected.split(/\r?\n/),function(){content+=(content?"\n":"")+"[li]"+this+"[/li]"});this.insertText("[ol]\n"+content+"\n[/ol]")}},table:{txtExec:["[table][tr][td]","[/td][/tr][/table]"]},horizontalrule:{txtExec:["[hr]"]},code:{txtExec:["[code]","[/code]"]},image:{txtExec:function(caller,selected){var editor=this;getEditorCommand("image")._dropDown(editor,caller,selected,function(url,width,height){var attrs="";if(width){attrs+=" width="+width}if(height){attrs+=" height="+height}editor.insertText("[img"+attrs+"]"+url+"[/img]")})}},email:{txtExec:function(caller,selected){var editor=this;getEditorCommand("email")._dropDown(editor,caller,function(url,text){editor.insertText("[email="+url+"]"+(text||selected||url)+"[/email]")})}},link:{txtExec:function(caller,selected){var editor=this;getEditorCommand("link")._dropDown(editor,caller,function(url,text){editor.insertText("[url="+url+"]"+(text||selected||url)+"[/url]")})}},quote:{txtExec:["[quote]","[/quote]"]},youtube:{txtExec:function(caller){var editor=this;getEditorCommand("youtube")._dropDown(editor,caller,function(id){editor.insertText("[youtube]"+id+"[/youtube]")})}},rtl:{txtExec:["[rtl]","[/rtl]"]},ltr:{txtExec:["[ltr]","[/ltr]"]}};var bbcodeHandlers={b:{tags:{b:null,strong:null},styles:{"font-weight":["bold","bolder","401","700","800","900"]},format:"[b]{0}[/b]",html:"<strong>{0}</strong>"},i:{tags:{i:null,em:null},styles:{"font-style":["italic","oblique"]},format:"[i]{0}[/i]",html:"<em>{0}</em>"},u:{tags:{u:null},styles:{"text-decoration":["underline"]},format:"[u]{0}[/u]",html:"<u>{0}</u>"},s:{tags:{s:null,strike:null},styles:{"text-decoration":["line-through"]},format:"[s]{0}[/s]",html:"<s>{0}</s>"},sub:{tags:{sub:null},format:"[sub]{0}[/sub]",html:"<sub>{0}</sub>"},sup:{tags:{sup:null},format:"[sup]{0}[/sup]",html:"<sup>{0}</sup>"},font:{tags:{font:{face:null}},styles:{"font-family":null},quoteType:QuoteType.never,format:function(element,content){var font;if(!is(element,"font")||!(font=attr(element,"face"))){font=css(element,"font-family")}return"[font="+_stripQuotes(font)+"]"+content+"[/font]"},html:'<font face="{defaultattr}">{0}</font>'},size:{tags:{font:{size:null}},styles:{"font-size":null},format:function(element,content){var fontSize=attr(element,"size"),size=2;if(!fontSize){fontSize=css(element,"fontSize")}if(fontSize.indexOf("px")>-1){fontSize=fontSize.replace("px","")-0;if(fontSize<12){size=1}if(fontSize>15){size=3}if(fontSize>17){size=4}if(fontSize>23){size=5}if(fontSize>31){size=6}if(fontSize>47){size=7}}else{size=fontSize}return"[size="+size+"]"+content+"[/size]"},html:'<font size="{defaultattr}">{!0}</font>'},color:{tags:{font:{color:null}},styles:{color:null},quoteType:QuoteType.never,format:function(elm,content){var color;if(!is(elm,"font")||!(color=attr(elm,"color"))){color=elm.style.color||css(elm,"color")}return"[color="+_normaliseColour(color)+"]"+content+"[/color]"},html:function(token,attrs,content){return'<font color="'+escapeEntities(_normaliseColour(attrs.defaultattr),true)+'">'+content+"</font>"}},ul:{tags:{ul:null},breakStart:true,isInline:false,skipLastLineBreak:true,format:"[ul]{0}[/ul]",html:"<ul>{0}</ul>"},list:{breakStart:true,isInline:false,skipLastLineBreak:true,html:"<ul>{0}</ul>"},ol:{tags:{ol:null},breakStart:true,isInline:false,skipLastLineBreak:true,format:"[ol]{0}[/ol]",html:"<ol>{0}</ol>"},li:{tags:{li:null},isInline:false,closedBy:["/ul","/ol","/list","*","li"],format:"[li]{0}[/li]",html:"<li>{0}</li>"},"*":{isInline:false,closedBy:["/ul","/ol","/list","*","li"],html:"<li>{0}</li>"},table:{tags:{table:null},isInline:false,isHtmlInline:true,skipLastLineBreak:true,format:"[table]{0}[/table]",html:"<table>{0}</table>"},tr:{tags:{tr:null},isInline:false,skipLastLineBreak:true,format:"[tr]{0}[/tr]",html:"<tr>{0}</tr>"},th:{tags:{th:null},allowsEmpty:true,isInline:false,format:"[th]{0}[/th]",html:"<th>{0}</th>"},td:{tags:{td:null},allowsEmpty:true,isInline:false,format:"[td]{0}[/td]",html:"<td>{0}</td>"},emoticon:{allowsEmpty:true,tags:{img:{src:null,"data-sceditor-emoticon":null}},format:function(element,content){return attr(element,EMOTICON_DATA_ATTR)+content},html:"{0}"},hr:{tags:{hr:null},allowsEmpty:true,isSelfClosing:true,isInline:false,format:"[hr]{0}",html:"<hr />"},img:{allowsEmpty:true,tags:{img:{src:null}},allowedChildren:["#"],quoteType:QuoteType.never,format:function(element,content){var width,height,attribs="",style=function(name){return element.style?element.style[name]:null};if(attr(element,EMOTICON_DATA_ATTR)){return content}width=attr(element,"width")||style("width");height=attr(element,"height")||style("height");if(element.complete&&(width||height)||width&&height){attribs="="+dom.width(element)+"x"+dom.height(element)}return"[img"+attribs+"]"+attr(element,"src")+"[/img]"},html:function(token,attrs,content){var undef,width,height,match,attribs="";width=attrs.width;height=attrs.height;if(attrs.defaultattr){match=attrs.defaultattr.split(/x/i);width=match[0];height=match.length===2?match[1]:match[0]}if(width!==undef){attribs+=' width="'+escapeEntities(width,true)+'"'}if(height!==undef){attribs+=' height="'+escapeEntities(height,true)+'"'}return"<img"+attribs+' src="'+escapeUriScheme(content)+'" />'}},url:{allowsEmpty:true,tags:{a:{href:null}},quoteType:QuoteType.never,format:function(element,content){var url=attr(element,"href");if(url.substr(0,7)==="mailto:"){return'[email="'+url.substr(7)+'"]'+content+"[/email]"}return"[url="+url+"]"+content+"[/url]"},html:function(token,attrs,content){attrs.defaultattr=escapeEntities(attrs.defaultattr,true)||content;return'<a href="'+escapeUriScheme(attrs.defaultattr)+'">'+content+"</a>"}},email:{quoteType:QuoteType.never,html:function(token,attrs,content){return'<a href="mailto:'+(escapeEntities(attrs.defaultattr,true)||content)+'">'+content+"</a>"}},quote:{tags:{blockquote:null},isInline:false,quoteType:QuoteType.never,format:function(element,content){var authorAttr="data-author";var author="";var cite;var children=element.children;for(var i=0;!cite&&i<children.length;i++){if(is(children[i],"cite")){cite=children[i]}}if(cite||attr(element,authorAttr)){author=cite&&cite.textContent||attr(element,authorAttr);attr(element,authorAttr,author);if(cite){element.removeChild(cite)}content=this.elementToBbcode(element);author="="+author.replace(/(^\s+|\s+$)/g,"");if(cite){element.insertBefore(cite,element.firstChild)}}return"[quote"+author+"]"+content+"[/quote]"},html:function(token,attrs,content){if(attrs.defaultattr){content="<cite>"+escapeEntities(attrs.defaultattr)+"</cite>"+content}return"<blockquote>"+content+"</blockquote>"}},code:{tags:{code:null},isInline:false,allowedChildren:["#","#newline"],format:"[code]{0}[/code]",html:"<code>{0}</code>"},left:{styles:{"text-align":["left","-webkit-left","-moz-left","-khtml-left"]},isInline:false,format:"[left]{0}[/left]",html:'<div align="left">{0}</div>'},center:{styles:{"text-align":["center","-webkit-center","-moz-center","-khtml-center"]},isInline:false,format:"[center]{0}[/center]",html:'<div align="center">{0}</div>'},right:{styles:{"text-align":["right","-webkit-right","-moz-right","-khtml-right"]},isInline:false,format:"[right]{0}[/right]",html:'<div align="right">{0}</div>'},justify:{styles:{"text-align":["justify","-webkit-justify","-moz-justify","-khtml-justify"]},isInline:false,format:"[justify]{0}[/justify]",html:'<div align="justify">{0}</div>'},youtube:{allowsEmpty:true,tags:{iframe:{"data-youtube-id":null}},format:function(element,content){element=attr(element,"data-youtube-id");return element?"[youtube]"+element+"[/youtube]":content},html:'<iframe width="560" height="315" frameborder="0" '+'src="https://www.youtube.com/embed/{0}?wmode=opaque" '+'data-youtube-id="{0}" allowfullscreen></iframe>'},rtl:{styles:{direction:["rtl"]},isInline:false,format:"[rtl]{0}[/rtl]",html:'<div style="direction: rtl">{0}</div>'},ltr:{styles:{direction:["ltr"]},isInline:false,format:"[ltr]{0}[/ltr]",html:'<div style="direction: ltr">{0}</div>'},ignore:{}};function formatBBCodeString(str,obj){return str.replace(/\{([^}]+)\}/g,function(match,group){var undef,escape=true;if(group.charAt(0)==="!"){escape=false;group=group.substring(1)}if(group==="0"){escape=false}if(obj[group]===undef){return match}return escape?escapeEntities(obj[group],true):obj[group]})}function removeFirstLastDiv(html){var node,next,removeDiv,output=document.createElement("div");removeDiv=function(node,isFirst){if(dom.hasStyling(node)){return}if(IE_BR_FIX||(node.childNodes.length!==1||!is(node.firstChild,"br"))){while(next=node.firstChild){output.insertBefore(next,node)}}if(isFirst){var lastChild=output.lastChild;if(node!==lastChild&&is(lastChild,"div")&&node.nextSibling===lastChild){output.insertBefore(document.createElement("br"),node)}}output.removeChild(node)};css(output,"display","none");output.innerHTML=html.replace(/<\/div>\n/g,"</div>");if((node=output.firstChild)&&is(node,"div")){removeDiv(node,true)}if((node=output.lastChild)&&is(node,"div")){removeDiv(node)}return output.innerHTML}function isFunction(fn){return typeof fn==="function"}function _stripQuotes(str){return str?str.replace(/\\(.)/g,"$1").replace(/^(["'])(.*?)\1$/,"$2"):str}function _formatString(str){var undef;var args=arguments;return str.replace(/\{(\d+)\}/g,function(_,matchNum){return args[matchNum-0+1]!==undef?args[matchNum-0+1]:"{"+matchNum+"}"})}var TOKEN_OPEN="open";var TOKEN_CONTENT="content";var TOKEN_NEWLINE="newline";var TOKEN_CLOSE="close";function TokenizeToken(type,name,val,attrs,children,closing){var base=this;base.type=type;base.name=name;base.val=val;base.attrs=attrs||{};base.children=children||[];base.closing=closing||null}TokenizeToken.prototype={clone:function(){var base=this;return new TokenizeToken(base.type,base.name,base.val,extend({},base.attrs),[],base.closing?base.closing.clone():null)},splitAt:function(splitAt){var offsetLength;var base=this;var clone=base.clone();var offset=base.children.indexOf(splitAt);if(offset>-1){offsetLength=base.children.length-offset;clone.children=base.children.splice(offset,offsetLength)}return clone}};function BBCodeParser(options){var base=this;base.opts=extend({},BBCodeParser.defaults,options);base.tokenize=function(str){var matches,type,i;var tokens=[];var tokenTypes=[{type:TOKEN_CONTENT,regex:/^([^\[\r\n]+|\[)/},{type:TOKEN_NEWLINE,regex:/^(\r\n|\r|\n)/},{type:TOKEN_OPEN,regex:/^\[[^\[\]]+\]/},{type:TOKEN_CLOSE,regex:/^\[\/[^\[\]]+\]/}];strloop:while(str.length){i=tokenTypes.length;while(i--){type=tokenTypes[i].type;if(!(matches=str.match(tokenTypes[i].regex))||!matches[0]){continue}tokens.push(tokenizeTag(type,matches[0]));str=str.substr(matches[0].length);continue strloop}if(str.length){tokens.push(tokenizeTag(TOKEN_CONTENT,str))}str=""}return tokens};function tokenizeTag(type,val){var matches,attrs,name,openRegex=/\[([^\]\s=]+)(?:([^\]]+))?\]/,closeRegex=/\[\/([^\[\]]+)\]/;if(type===TOKEN_OPEN&&(matches=val.match(openRegex))){name=lower(matches[1]);if(matches[2]&&(matches[2]=matches[2].trim())){attrs=tokenizeAttrs(matches[2])}}if(type===TOKEN_CLOSE&&(matches=val.match(closeRegex))){name=lower(matches[1])}if(type===TOKEN_NEWLINE){name="#newline"}if(!name||(type===TOKEN_OPEN||type===TOKEN_CLOSE)&&!bbcodeHandlers[name]){type=TOKEN_CONTENT;name="#"}return new TokenizeToken(type,name,val,attrs)}function tokenizeAttrs(attrs){var matches,attrRegex=/([^\s=]+)=(?:(?:(["'])((?:\\\2|[^\2])*?)\2)|((?:.(?!\s\S+=))*.))/g,ret={};if(attrs.charAt(0)==="="&&attrs.indexOf("=",1)<0){ret.defaultattr=_stripQuotes(attrs.substr(1))}else{if(attrs.charAt(0)==="="){attrs="defaultattr"+attrs}while(matches=attrRegex.exec(attrs)){ret[lower(matches[1])]=_stripQuotes(matches[3])||matches[4]}}return ret}base.parse=function(str,preserveNewLines){var ret=parseTokens(base.tokenize(str));var opts=base.opts;if(opts.fixInvalidNesting){fixNesting(ret)}normaliseNewLines(ret,null,preserveNewLines);if(opts.removeEmptyTags){removeEmpty(ret)}return ret};function hasTag(name,type,arr){var i=arr.length;while(i--){if(arr[i].type===type&&arr[i].name===name){return true}}return false}function isChildAllowed(parent,child){var parentBBCode=parent?bbcodeHandlers[parent.name]:{},allowedChildren=parentBBCode.allowedChildren;if(base.opts.fixInvalidChildren&&allowedChildren){return allowedChildren.indexOf(child.name||"#")>-1}return true}function parseTokens(toks){var token,bbcode,curTok,clone,i,next,cloned=[],output=[],openTags=[],currentTag=function(){return last(openTags)},addTag=function(token){if(currentTag()){currentTag().children.push(token)}else{output.push(token)}},closesCurrentTag=function(name){return currentTag()&&(bbcode=bbcodeHandlers[currentTag().name])&&bbcode.closedBy&&bbcode.closedBy.indexOf(name)>-1};while(token=toks.shift()){next=toks[0];if(!isChildAllowed(currentTag(),token)){if(token.type!==TOKEN_CLOSE||!currentTag()||token.name!==currentTag().name){token.name="#";token.type=TOKEN_CONTENT}}switch(token.type){case TOKEN_OPEN:if(closesCurrentTag(token.name)){openTags.pop()}addTag(token);bbcode=bbcodeHandlers[token.name];if(bbcode&&!bbcode.isSelfClosing&&(bbcode.closedBy||hasTag(token.name,TOKEN_CLOSE,toks))){openTags.push(token)}else if(!bbcode||!bbcode.isSelfClosing){token.type=TOKEN_CONTENT}break;case TOKEN_CLOSE:if(currentTag()&&token.name!==currentTag().name&&closesCurrentTag("/"+token.name)){openTags.pop()}if(currentTag()&&token.name===currentTag().name){currentTag().closing=token;openTags.pop()}else if(hasTag(token.name,TOKEN_OPEN,openTags)){while(curTok=openTags.pop()){if(curTok.name===token.name){curTok.closing=token;break}clone=curTok.clone();if(cloned.length){clone.children.push(last(cloned))}cloned.push(clone)}if(next&&next.type===TOKEN_NEWLINE){bbcode=bbcodeHandlers[token.name];if(bbcode&&bbcode.isInline===false){addTag(next);toks.shift()}}addTag(last(cloned));i=cloned.length;while(i--){openTags.push(cloned[i])}cloned.length=0}else{token.type=TOKEN_CONTENT;addTag(token)}break;case TOKEN_NEWLINE:if(currentTag()&&next&&closesCurrentTag((next.type===TOKEN_CLOSE?"/":"")+next.name)){if(!(next.type===TOKEN_CLOSE&&next.name===currentTag().name)){bbcode=bbcodeHandlers[currentTag().name];if(bbcode&&bbcode.breakAfter){openTags.pop()}else if(bbcode&&bbcode.isInline===false&&base.opts.breakAfterBlock&&bbcode.breakAfter!==false){openTags.pop()}}}addTag(token);break;default:addTag(token);break}}return output}function normaliseNewLines(children,parent,onlyRemoveBreakAfter){var token,left,right,parentBBCode,bbcode,removedBreakEnd,removedBreakBefore,remove;var childrenLength=children.length;if(parent){parentBBCode=bbcodeHandlers[parent.name]}var i=childrenLength;while(i--){if(!(token=children[i])){continue}if(token.type===TOKEN_NEWLINE){left=i>0?children[i-1]:null;right=i<childrenLength-1?children[i+1]:null;remove=false;if(!onlyRemoveBreakAfter&&parentBBCode&&parentBBCode.isSelfClosing!==true){if(!left){if(parentBBCode.isInline===false&&base.opts.breakStartBlock&&parentBBCode.breakStart!==false){remove=true}if(parentBBCode.breakStart){remove=true}}else if(!removedBreakEnd&&!right){if(parentBBCode.isInline===false&&base.opts.breakEndBlock&&parentBBCode.breakEnd!==false){remove=true}if(parentBBCode.breakEnd){remove=true}removedBreakEnd=remove}}if(left&&left.type===TOKEN_OPEN){if(bbcode=bbcodeHandlers[left.name]){if(!onlyRemoveBreakAfter){if(bbcode.isInline===false&&base.opts.breakAfterBlock&&bbcode.breakAfter!==false){remove=true}if(bbcode.breakAfter){remove=true}}else if(bbcode.isInline===false){remove=true}}}if(!onlyRemoveBreakAfter&&!removedBreakBefore&&right&&right.type===TOKEN_OPEN){if(bbcode=bbcodeHandlers[right.name]){if(bbcode.isInline===false&&base.opts.breakBeforeBlock&&bbcode.breakBefore!==false){remove=true}if(bbcode.breakBefore){remove=true}removedBreakBefore=remove;if(remove){children.splice(i,1);continue}}}if(remove){children.splice(i,1)}removedBreakBefore=false}else if(token.type===TOKEN_OPEN){normaliseNewLines(token.children,token,onlyRemoveBreakAfter)}}}function fixNesting(children,parents,insideInline,rootArr){var token,i,parent,parentIndex,parentParentChildren,right;var isInline=function(token){var bbcode=bbcodeHandlers[token.name];return!bbcode||bbcode.isInline!==false};parents=parents||[];rootArr=rootArr||children;for(i=0;i<children.length;i++){if(!(token=children[i])||token.type!==TOKEN_OPEN){continue}if(insideInline&&!isInline(token)){parent=last(parents);right=parent.splitAt(token);parentParentChildren=parents.length>1?parents[parents.length-2].children:rootArr;if(isChildAllowed(token,parent)){var clone=parent.clone();clone.children=token.children;token.children=[clone]}parentIndex=parentParentChildren.indexOf(parent);if(parentIndex>-1){right.children.splice(0,1);parentParentChildren.splice(parentIndex+1,0,token,right);var next=right.children[0];if(next&&next.type===TOKEN_NEWLINE){if(!isInline(token)){right.children.splice(0,1);parentParentChildren.splice(parentIndex+2,0,next)}}return}}parents.push(token);fixNesting(token.children,parents,insideInline||isInline(token),rootArr);parents.pop()}}function removeEmpty(tokens){var token,bbcode;var isTokenWhiteSpace=function(children){var j=children.length;while(j--){var type=children[j].type;if(type===TOKEN_OPEN||type===TOKEN_CLOSE){return false}if(type===TOKEN_CONTENT&&/\S|\u00A0/.test(children[j].val)){return false}}return true};var i=tokens.length;while(i--){if(!(token=tokens[i])||token.type!==TOKEN_OPEN){continue}bbcode=bbcodeHandlers[token.name];removeEmpty(token.children);if(isTokenWhiteSpace(token.children)&&bbcode&&!bbcode.isSelfClosing&&!bbcode.allowsEmpty){tokens.splice.apply(tokens,[i,1].concat(token.children))}}}base.toHTML=function(str,preserveNewLines){return convertToHTML(base.parse(str,preserveNewLines),true)};function convertToHTML(tokens,isRoot){var undef,token,bbcode,content,html,needsBlockWrap,blockWrapOpen,isInline,lastChild,ret=[];isInline=function(bbcode){return(!bbcode||(bbcode.isHtmlInline!==undef?bbcode.isHtmlInline:bbcode.isInline))!==false};while(tokens.length>0){if(!(token=tokens.shift())){continue}if(token.type===TOKEN_OPEN){lastChild=token.children[token.children.length-1]||{};bbcode=bbcodeHandlers[token.name];needsBlockWrap=isRoot&&isInline(bbcode);content=convertToHTML(token.children,false);if(bbcode&&bbcode.html){if(!isInline(bbcode)&&isInline(bbcodeHandlers[lastChild.name])&&!bbcode.isPreFormatted&&!bbcode.skipLastLineBreak){if(!IE_BR_FIX){content+="<br />"}}if(!isFunction(bbcode.html)){token.attrs["0"]=content;html=formatBBCodeString(bbcode.html,token.attrs)}else{html=bbcode.html.call(base,token,token.attrs,content)}}else{html=token.val+content+(token.closing?token.closing.val:"")}}else if(token.type===TOKEN_NEWLINE){if(!isRoot){ret.push("<br />");continue}if(!blockWrapOpen){ret.push("<div>")}if(!IE_BR_FIX){ret.push("<br />")}if(!tokens.length){ret.push("<br />")}ret.push("</div>\n");blockWrapOpen=false;continue}else{needsBlockWrap=isRoot;html=escapeEntities(token.val,true)}if(needsBlockWrap&&!blockWrapOpen){ret.push("<div>");blockWrapOpen=true}else if(!needsBlockWrap&&blockWrapOpen){ret.push("</div>\n");blockWrapOpen=false}ret.push(html)}if(blockWrapOpen){ret.push("</div>\n")}return ret.join("")}base.toBBCode=function(str,preserveNewLines){return convertToBBCode(base.parse(str,preserveNewLines))};function convertToBBCode(toks){var token,attr,bbcode,isBlock,isSelfClosing,quoteType,breakBefore,breakStart,breakEnd,breakAfter,ret=[];while(toks.length>0){if(!(token=toks.shift())){continue}bbcode=bbcodeHandlers[token.name];isBlock=!(!bbcode||bbcode.isInline!==false);isSelfClosing=bbcode&&bbcode.isSelfClosing;breakBefore=isBlock&&base.opts.breakBeforeBlock&&bbcode.breakBefore!==false||bbcode&&bbcode.breakBefore;breakStart=isBlock&&!isSelfClosing&&base.opts.breakStartBlock&&bbcode.breakStart!==false||bbcode&&bbcode.breakStart;breakEnd=isBlock&&base.opts.breakEndBlock&&bbcode.breakEnd!==false||bbcode&&bbcode.breakEnd;breakAfter=isBlock&&base.opts.breakAfterBlock&&bbcode.breakAfter!==false||bbcode&&bbcode.breakAfter;quoteType=(bbcode?bbcode.quoteType:null)||base.opts.quoteType||QuoteType.auto;if(!bbcode&&token.type===TOKEN_OPEN){ret.push(token.val);if(token.children){ret.push(convertToBBCode(token.children))}if(token.closing){ret.push(token.closing.val)}}else if(token.type===TOKEN_OPEN){if(breakBefore){ret.push("\n")}ret.push("["+token.name);if(token.attrs){if(token.attrs.defaultattr){ret.push("=",quote(token.attrs.defaultattr,quoteType,"defaultattr"));delete token.attrs.defaultattr}for(attr in token.attrs){if(token.attrs.hasOwnProperty(attr)){ret.push(" ",attr,"=",quote(token.attrs[attr],quoteType,attr))}}}ret.push("]");if(breakStart){ret.push("\n")}if(token.children){ret.push(convertToBBCode(token.children))}if(!isSelfClosing&&!bbcode.excludeClosing){if(breakEnd){ret.push("\n")}ret.push("[/"+token.name+"]")}if(breakAfter){ret.push("\n")}if(token.closing&&isSelfClosing){ret.push(token.closing.val)}}else{ret.push(token.val)}}return ret.join("")}function quote(str,quoteType,name){var needsQuotes=/\s|=/.test(str);if(isFunction(quoteType)){return quoteType(str,name)}if(quoteType===QuoteType.never||quoteType===QuoteType.auto&&!needsQuotes){return str}return'"'+str.replace("\\","\\\\").replace('"','\\"')+'"'}function last(arr){if(arr.length){return arr[arr.length-1]}return null}function lower(str){return str.toLowerCase()}}BBCodeParser.QuoteType=QuoteType;BBCodeParser.defaults={breakBeforeBlock:false,breakStartBlock:false,breakEndBlock:false,breakAfterBlock:true,removeEmptyTags:true,fixInvalidNesting:true,fixInvalidChildren:true,quoteType:QuoteType.auto};function toHex(number){number=parseInt(number,10);if(isNaN(number)){return"00"}number=Math.max(0,Math.min(number,255)).toString(16);return number.length<2?"0"+number:number}function _normaliseColour(colorStr){var match;colorStr=colorStr||"#000";if(match=colorStr.match(/rgb\((\d{1,3}),\s*?(\d{1,3}),\s*?(\d{1,3})\)/i)){return"#"+toHex(match[1])+toHex(match[2])+toHex(match[3])}if(match=colorStr.match(/#([0-f])([0-f])([0-f])\s*?$/i)){return"#"+match[1]+match[1]+match[2]+match[2]+match[3]+match[3]}return colorStr}function bbcodeFormat(){var base=this;base.stripQuotes=_stripQuotes;var tagsToBBCodes={};var stylesToBBCodes={};var validChildren={ul:["li","ol","ul"],ol:["li","ol","ul"],table:["tr"],tr:["td","th"],code:["br","p","div"]};function buildBbcodeCache(){each(bbcodeHandlers,function(bbcode){var isBlock,tags=bbcodeHandlers[bbcode].tags,styles=bbcodeHandlers[bbcode].styles;if(tags){each(tags,function(tag,values){isBlock=bbcodeHandlers[bbcode].isInline===false;tagsToBBCodes[tag]=tagsToBBCodes[tag]||{};tagsToBBCodes[tag][isBlock]=tagsToBBCodes[tag][isBlock]||{};tagsToBBCodes[tag][isBlock][bbcode]=values})}if(styles){each(styles,function(style,values){isBlock=bbcodeHandlers[bbcode].isInline===false;stylesToBBCodes[isBlock]=stylesToBBCodes[isBlock]||{};stylesToBBCodes[isBlock][style]=stylesToBBCodes[isBlock][style]||{};stylesToBBCodes[isBlock][style][bbcode]=values})}})}function handleStyles(element,content,blockLevel){var styleValue,format,getStyle=dom.getStyle;blockLevel=!!blockLevel;if(!stylesToBBCodes[blockLevel]){return content}each(stylesToBBCodes[blockLevel],function(property,bbcodes){styleValue=getStyle(element,property);if(!styleValue||getStyle(element.parentNode,property)===styleValue){return}each(bbcodes,function(bbcode,values){if(!values||values.indexOf(styleValue.toString())>-1){format=bbcodeHandlers[bbcode].format;if(isFunction(format)){content=format.call(base,element,content)}else{content=_formatString(format,content)}}})});return content}function handleBlockNewlines(element,content){var tag=element.nodeName.toLowerCase();var isInline=dom.isInline;if(!isInline(element,true)||tag==="br"){var isLastBlockChild,parent,parentLastChild,previousSibling=element.previousSibling;while(previousSibling&&previousSibling.nodeType===1&&!is(previousSibling,"br")&&isInline(previousSibling,true)&&!previousSibling.firstChild){previousSibling=previousSibling.previousSibling}do{parent=element.parentNode;parentLastChild=parent&&parent.lastChild;isLastBlockChild=parentLastChild===element;element=parent}while(parent&&isLastBlockChild&&isInline(parent,true));if(!isLastBlockChild||tag==="li"||tag==="br"&&IE_BR_FIX){content+="\n"}if(tag!=="br"&&previousSibling&&!is(previousSibling,"br")&&isInline(previousSibling,true)){content="\n"+content}}return content}function handleTags(element,content,blockLevel){var convertBBCode,format,tag=element.nodeName.toLowerCase();blockLevel=!!blockLevel;if(tagsToBBCodes[tag]&&tagsToBBCodes[tag][blockLevel]){each(tagsToBBCodes[tag][blockLevel],function(bbcode,bbcodeAttribs){if(bbcodeAttribs){convertBBCode=false;each(bbcodeAttribs,function(attrib,values){if(!attr(element,attrib)||values&&values.indexOf(attr(element,attrib))<0){return}convertBBCode=true;return false});if(!convertBBCode){return}}format=bbcodeHandlers[bbcode].format;if(isFunction(format)){content=format.call(base,element,content)}else{content=_formatString(format,content)}})}return content}function elementToBbcode(element){var toBBCode=function(node,vChildren){var ret="";dom.traverse(node,function(node){var curTag="",nodeType=node.nodeType,tag=node.nodeName.toLowerCase(),vChild=validChildren[tag],firstChild=node.firstChild,isValidChild=true;if(typeof vChildren==="object"){isValidChild=vChildren.indexOf(tag)>-1;if(is(node,"img")&&attr(node,EMOTICON_DATA_ATTR)){isValidChild=true}if(!isValidChild){vChild=vChildren}}if(nodeType!==3&&nodeType!==1){return}if(nodeType===1){if(is(node,".sceditor-nlf")){if(!firstChild||!IE_BR_FIX&&node.childNodes.length===1&&/br/i.test(firstChild.nodeName)){return}}if(tag!=="iframe"){curTag=toBBCode(node,vChild)}if(isValidChild){if(tag!=="code"){curTag=handleStyles(node,curTag);curTag=handleTags(node,curTag);curTag=handleStyles(node,curTag,true)}curTag=handleTags(node,curTag,true);ret+=handleBlockNewlines(node,curTag)}else{ret+=curTag}}else{ret+=node.nodeValue}},false,true);return ret};return toBBCode(element)}base.init=function(){base.opts=this.opts;base.elementToBbcode=elementToBbcode;buildBbcodeCache();this.commands=extend(true,{},defaultCommandsOverrides,this.commands);this.toBBCode=base.toSource;this.fromBBCode=base.toHtml};function toHtml(asFragment,source,legacyAsFragment){var parser=new BBCodeParser(base.opts.parserOptions);var html=parser.toHTML(base.opts.bbcodeTrim?source.trim():source);return asFragment||legacyAsFragment?removeFirstLastDiv(html):html}function toSource(asFragment,html,context,parent){context=context||document;var bbcode,elements;var containerParent=context.createElement("div");var container=context.createElement("div");var parser=new BBCodeParser(base.opts.parserOptions);container.innerHTML=html;css(containerParent,"visibility","hidden");containerParent.appendChild(container);context.body.appendChild(containerParent);if(asFragment){containerParent.insertBefore(context.createTextNode("#"),containerParent.firstChild);containerParent.appendChild(context.createTextNode("#"))}if(parent){css(container,"whiteSpace",css(parent,"whiteSpace"))}elements=container.getElementsByClassName("sceditor-ignore");while(elements.length){elements[0].parentNode.removeChild(elements[0])}dom.removeWhiteSpace(containerParent);bbcode=elementToBbcode(container);context.body.removeChild(containerParent);bbcode=parser.toBBCode(bbcode,true);if(base.opts.bbcodeTrim){bbcode=bbcode.trim()}return bbcode}base.toHtml=toHtml.bind(null,false);base.fragmentToHtml=toHtml.bind(null,true);base.toSource=toSource.bind(null,false);base.fragmentToSource=toSource.bind(null,true)}bbcodeFormat.get=function(name){return bbcodeHandlers[name]||null};bbcodeFormat.set=function(name,bbcode){if(name&&bbcode){bbcode=extend(bbcodeHandlers[name]||{},bbcode);bbcode.remove=function(){delete bbcodeHandlers[name]};bbcodeHandlers[name]=bbcode}return this};bbcodeFormat.rename=function(name,newName){if(name in bbcodeHandlers){bbcodeHandlers[newName]=bbcodeHandlers[name];delete bbcodeHandlers[name]}return this};bbcodeFormat.remove=function(name){if(name in bbcodeHandlers){delete bbcodeHandlers[name]}return this};bbcodeFormat.formatBBCodeString=formatBBCodeString;sceditor.formats.bbcode=bbcodeFormat;sceditor.BBCodeParser=BBCodeParser})(sceditor);